C****************************************************************
C     PROGRAM ADI : BI-DFT.FOR                                  *
C     TARIH       : TEMMUZ 1998                                 *
C     YAZAN       : FUNDA AKLEMAN & LEVENT SEVGI                *
C     AMAC        : TDFD SACILMA VERILERININ DFT ILE FOURIER    *
C                   ANALIZINI YAPMAK                            *
C****************************************************************
      REAL FETETA,FEPHI,TIME,ACI,PI,EX(1500),EY(1500),EZ(1500)
      COMPLEX CFETETA,CFEPHI,J,CF,CX,CY,CZ
      
      OPEN(UNIT=30,FILE='BIRCS.INP')

      OPEN(UNIT=22,FILE='F-BIRCS.DAT')
      OPEN(UNIT=11,FILE='F-BIFAR.DAT')
      OPEN(UNIT=33,FILE='SOURCE.DAT')


      READ(30,*) NTYPE        !1-5
      READ(30,*) O_LENGTH     !LONGEST DIMENSION

      WRITE(*,*) 'L = ? [in WAVELENGTH]'
      READ(*,*) A_LAMBDA

      FREQ=A_LAMBDA*3.E8/O_LENGTH !WAVELENGTH - FREQUENCY TRANSFORMATION
	FREQ=FREQ*1.E-9             ! FREQUENCY IN GHz

      IF (NTYPE.EQ.1) THEN
        DELX=O_LENGTH/80.
      ELSE
        DELX=O_LENGTH/40.
      ENDIF


      NACI=145 
      NT=801

      DO I=1,1500
       EX(I)=0.
       EY(I)=0.
       EZ(I)=0.
      ENDDO
      
      PI=4.0*ATAN(1.0)
      J=CMPLX(0.0,1.0)
      ARG=2.0*PI
      CF=(.0,.0)

      DO K=1,(NT-201)
         READ(33,*,ERR=100) TT,EX(K),EY(K),EZ(K)
	END DO
100   CONTINUE


      AMAX=-10000.
      AMIN=10000.
      DO I=1,NACI
      
       CFETETA=CMPLX(0.0,0.0)
       CFEPHI=CMPLX(0.0,0.0)
       CF=CMPLX(.0,.0)
       CX=cmplx(.0,.0)
       CY=cmplx(.0,.0)
       CZ=cmplx(.0,.0)


       DO K=1,NT
	   READ(11,*) ACI,TIME,FETETA,FEPHI
	   CFETETA=CFETETA+FETETA*CEXP(-J*ARG*FREQ*TIME)
	   CFEPHI=CFEPHI+FEPHI*CEXP(-J*ARG*FREQ*TIME)
         CX=CX+EX(K)*CEXP(-J*ARG*FREQ*TIME)
         CY=CY+EY(K)*CEXP(-J*ARG*FREQ*TIME)
         CZ=CZ+EZ(K)*CEXP(-J*ARG*FREQ*TIME)
       END DO

       CF=CSQRT(CX**2+CY**2+CZ**2)
       B1=4.*PI*CABS(CFETETA)**2/CABS(CF)**2
       B2=4.*PI*CABS(CFEPHI)**2/CABS(CF)**2
       WRITE(22,*) ACI,B1,B2
       WRITE(*,*) I,B1,B2
       IF(b1.GT.AMAX) AMAX=b1
       IF(b1.LT.AMIN) AMIN=b1

      END DO
      WRITE(*,*) 'AMAX=',(AMAX)
      WRITE(*,*) 'AMIN=',(AMIN)

      CLOSE(UNIT=11)
      CLOSE(UNIT=22)
      CLOSE(UNIT=33)

      STOP
      END
      
