C******************************************************
C     PROGRAM ADI : FDSAR.FOR                         *
C     AMAC        : FDTD+PML ILE SAR ANALIZI          *
C     TARIH       : MART 2002                         *
C******************************************************
      INCLUDE 'FDSAR.PAR'

      OPEN(UNIT=15,FILE='SAR.INP')
      OPEN(UNIT=55,FILE='FD-FIELD.DAT')
      OPEN(UNIT=60,FILE='FD-SAR.DAT')
      OPEN(UNIT=65,FILE='FD-POWER.DAT')
      OPEN(UNIT=70,FILE='SOURCE.DAT')
      OPEN(UNIT=80,FILE='FD-SARX.DAT')
      OPEN(UNIT=90,FILE='FD-SARZ.DAT')

      REFTH=1.E-5
      ESIGMAM=-3.*EPS0*3.E8*ALOG(REFTH)/(2.* NPML *DELX)
      HSIGMAM=ESIGMAM*XMU0/EPS0
      
      CALL ZERO

      READ (15,*) NTER
      READ (15,*) NPOL
      READ (15,*) NSEN
      IF(NSEN.GT.0) THEN
        DO L=1,NSEN
          READ (15,*) EPSR,SIGMA(L+1),DENSTY(L+1)
          EPS(L+1)=EPS0*EPSR
        ENDDO
      ENDIF
      DO I=1,3
        READ (15,*) KPOL(I),IOBS(I),JOBS(I),KOBS(I)
      ENDDO
      READ(15,*) IAMP
      CLOSE (15)
      IF(IAMP.EQ.0) THEN
         AMP=1
      ELSE
         AMP=10840
      ENDIF

      CALL SETUP
      CALL BUILD
      CALL ANTENNA ! BUILD 1-CELL ANTENNA
C**********************
C  PML SUBROTINES     *
C**********************

      CALL PMLCUBE
      CALL PMLSETUP

C**********************
C  ANA FDTD DONGUSU   *
C**********************

      T=0.0
      AKIE=0.0
      
      DO 100 N=1,NSTOP
                                      
        WRITE(*,*) N,EZ(ib,jb,kb),EZ(19+NPML,20+NPML,15+NPML)
     >  ,EZ(20+NPML,20+NPML,15+NPML)

        NTIME=N
C********************
C ELEKTRIK ALANLAR  *
C********************
	CALL EXFLD
        CALL EYFLD
	CALL EZFLD

C***************************
C SINIR (PEC)              *
C***************************
C        CALL PEC
	T=T+DT/2.
           
C***********************
C MAGNETIK ALANLAR     *
C***********************
       CALL HXFLD
       CALL HYFLD
       CALL HZFLD
        
	T=T+DT/2.
      
C************************************
        CALL POYNTING
        IF(NSEN.GT.0) THEN
          CALL ABSORBED  !CALCULATE ABSORBED POWER
        ENDIF
        CALL POWER 
        IF(N.GT.NP7) THEN
          IF(NSEN.GT.0) CALL SAR_PEAK
          IF(NSEN.GT.0.AND.N.EQ.1097) CALL SAR_LINE
        ENDIF
        CALL OUTPUT
 100  CONTINUE
C**************************
C   END OF MAIN LOOP      *
C**************************
      CLOSE(31)
      
      STOP
      END

C*************************************************
      SUBROUTINE ANTENNA
      INCLUDE 'FDSAR.PAR'

      IF(NPOL.EQ.1) THEN
        CALL DCUBE(IB,JB,KB+1,1,1,NANT,1) ! UPPER PART ALONG Z
        CALL DCUBE(IB,JB,KB-NANT,1,1,NANT,1) ! LOWER PART ALONG Z
      ELSE
        CALL DCUBE(IB,JB+1,KB,1,NANT,1,1) ! UPPER PART ALONG Y
        CALL DCUBE(IB,JB-NANT,KB,1,NANT,1,1) ! LOWER PART ALONG Y
      ENDIF

      RETURN
      END

C*************************************************
      SUBROUTINE OUTPUT
      INCLUDE 'FDSAR.PAR'

      DO L=1,3
        K=KOBS(L)
        J=JOBS(L)
        I=IOBS(L)
        M=KPOL(L)
        EFLD(L)=0.0
        EE=0.0
        IF(M.EQ.1) THEN
          EE=0.25*(EX(I,J,K)+EX(I,J+1,K)+EX(I,J+1,K+1)+EX(I,J,K+1))
        ELSEIF(M.EQ.2) THEN
          EE=0.25*(EY(I,J,K)+EY(I+1,J,K)+EY(I+1,J,K+1)+EY(I,J,K+1))
        ELSEIF(M.EQ.3) THEN
          EE=0.25*(EZ(I,J,K)+EZ(I+1,J,K)+EZ(I+1,J+1,K)+EZ(I,J+1,K))
        ENDIF
        EFLD(L)=EE
      ENDDO
      WRITE(55,*) T*1.E9,(EFLD(L),L=1,3)

      RETURN
      END

C*************************************************
      SUBROUTINE BUILD
      INCLUDE 'FDSAR.PAR'

      IF(NSEN.EQ.1) THEN
       CALL DCUBE(20+NPML,20+NPML,15+NPML,10,10,12,2) !DIE1
      ELSEIF(NSEN.EQ.2) THEN
       CALL DCUBE(20+NPML,20+NPML,15+NPML,5,10,12,2) !DIE1
       CALL DCUBE(25+NPML,20+NPML,15+NPML,5,10,12,3) !DIE2
      ENDIF

      RETURN
      END

C********************************************************
      SUBROUTINE DCUBE (ISTART,JSTART,KSTART,NXWIDE,NYWIDE,NZWIDE,MTYPE)
      INCLUDE 'FDSAR.PAR'
C
C     THIS SUBROUTINE SETS ALL TWELVE IDXXX COMPONENTS FOR ONE CUBE
C     TO THE SAME MATERIAL TYPE SPECIFIED BY MTYPE.  IF NXWIDE, NYWIDE,
C     OR NZWIDE=0, THEN ONLY 4 IDXXX ARRAY COMPONENTS WILL BE SET
C     CORRESPONDING TO AN INFINITELY THIN PLATE.  THE SUBROUTINE IS MOST
C     USEFUL CONSTRUCTING OBJECTS WITH MANY CELLS OF THE SAME MATERIAL
C     (I.E. CUBES, PEC PLATES, ETC.).  THIS SUBROUTINE DOES NOT
C     AUTOMATICALLY DO WIRES!
C
      IMAX=ISTART+NXWIDE-1
      JMAX=JSTART+NYWIDE-1
      KMAX=KSTART+NZWIDE-1
C
      IF (NXWIDE.EQ.0) THEN
	DO 20 K=KSTART,KMAX
	  DO 10 J=JSTART,JMAX
	    IDTWO(ISTART,J,K)=MTYPE
	    IDTWO(ISTART,J,K+1)=MTYPE
	    IDTHRE(ISTART,J,K)=MTYPE
	    IDTHRE(ISTART,J+1,K)=MTYPE
 10       CONTINUE
 20     CONTINUE
      ELSEIF (NYWIDE.EQ.0) THEN
	DO 40 K=KSTART,KMAX
	  DO 30 I=ISTART,IMAX
	    IDONE(I,JSTART,K)=MTYPE
	    IDONE(I,JSTART,K+1)=MTYPE
	    IDTHRE(I,JSTART,K)=MTYPE
	    IDTHRE(I+1,JSTART,K)=MTYPE
 30       CONTINUE
 40     CONTINUE
      ELSEIF (NZWIDE.EQ.0) THEN
	DO 60 J=JSTART,JMAX
	  DO 50 I=ISTART,IMAX
	    IDONE(I,J,KSTART)=MTYPE
	    IDONE(I,J+1,KSTART)=MTYPE
	    IDTWO(I,J,KSTART)=MTYPE
	    IDTWO(I+1,J,KSTART)=MTYPE
 50       CONTINUE
 60     CONTINUE
      ELSE
	DO 90 K=KSTART,KMAX
	  DO 80 J=JSTART,JMAX
	    DO 70 I=ISTART,IMAX
	      IDONE(I,J,K)=MTYPE
	      IDONE(I,J,K+1)=MTYPE
	      IDONE(I,J+1,K+1)=MTYPE
	      IDONE(I,J+1,K)=MTYPE
	      IDTWO(I,J,K)=MTYPE
	      IDTWO(I+1,J,K)=MTYPE
	      IDTWO(I+1,J,K+1)=MTYPE
	      IDTWO(I,J,K+1)=MTYPE
	      IDTHRE(I,J,K)=MTYPE
	      IDTHRE(I+1,J,K)=MTYPE
	      IDTHRE(I+1,J+1,K)=MTYPE
	      IDTHRE(I,J+1,K)=MTYPE
 70         CONTINUE
 80       CONTINUE
 90     CONTINUE
      ENDIF
      RETURN
      END
C********************************************************
      SUBROUTINE PMLCUBE 
      INCLUDE 'FDSAR.PAR'
C
        DO K=1,NZ
        DO J=1,NY
        DO I=1,NX
C
C         PML KOSELERI
C
         IF (I.LE.NXB.AND.J.LE.NYB.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=1
         ELSEIF (I.GE.NXS.AND.J.LE.NYB.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=2
         ELSEIF (I.LE.NXB.AND.J.LE.NYB.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=3
         ELSEIF (I.GE.NXS.AND.J.LE.NYB.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=4
         ELSEIF (I.LE.NXB.AND.J.GE.NYS.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=5
         ELSEIF (I.GE.NXS.AND.J.GE.NYS.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=6
         ELSEIF (I.LE.NXB.AND.J.GE.NYS.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=7
         ELSEIF (I.GE.NXS.AND.J.GE.NYS.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=8
C
C         PML KENARLARI
C
         ELSEIF (I.LE.NXB.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=9
         ELSEIF (I.GE.NXS.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=10
         ELSEIF (I.LE.NXB.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=11
         ELSEIF (I.GE.NXS.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=12
C
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GE.NYS.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=13
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GE.NYS.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=14
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.LE.NYB.AND.K.LE.NZB) THEN
            IDPML(I,J,K)=15
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.LE.NYB.AND.K.GE.NZS) THEN
            IDPML(I,J,K)=16
C
         ELSEIF (I.LE.NXB.AND.J.GE.NYS.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(I,J,K)=17
         ELSEIF (I.GE.NXS.AND.J.GE.NYS.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(I,J,K)=18
         ELSEIF (I.LE.NXB.AND.J.LE.NYB.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(I,J,K)=19
         ELSEIF (I.GE.NXS.AND.J.LE.NYB.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(I,J,K)=20
C
C         PML YUZEYLERI (GENEL)
C
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.LE.NZB) THEN
          IDPML(I,J,K)=21
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.GE.NZS) THEN
          IDPML(I,J,K)=22
         ELSEIF (I.LE.NXB.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(I,J,K)=23
         ELSEIF (I.GE.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(I,J,K)=24
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.LE.NYB
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(I,J,K)=25
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GE.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(I,J,K)=26
         ELSE
           IDPML(I,J,K)=27
         ENDIF
        ENDDO
        ENDDO
        ENDDO

      RETURN
      END
C*******************************************************

      SUBROUTINE SETUP
      INCLUDE 'FDSAR.PAR'
C
      C=1.0/SQRT(XMU0*EPS0)
      PI=4.0*ATAN(1.0)

C
      DTXI=C/DELX
      DTYI=C/DELY
      DTZI=C/DELZ
C
      DT=DELX/(2.*C) 
      NP = 2./(F0*DT)
      NP7= 7./(F0*DT)

C     DEFINE CONSTITUTIVE PARAMETERS--EPS,SIGMA
C     THIS CODE ASSUMES THAT THE DIELECTRIC MATERIALS ALL HAVE
C     A PERMEABILITY OF MU0.  IF YOU NEED A MATERIAL WITH MAGNETIC
C     PROPERTIES, USE ANOTHER FDTD CODE SUCH AS FDTDC, FDTDD, FDTDG
C     OR FDTDH.
C
C     THESE CORRESPOND TO MATERIAL TYPES IN IDONE, IDTWO, AND
C     IDTHRE ARRAYS.  SEE COMMENTS IN SUBROUTINE BUILD
C
C     VALID CASES:  IDXXX(I,J,K)  = 0 FOR FREE SPACE IN CELL I,J,K
C                                 = 1 FOR PEC
C                                 = 2-9 FOR LOSSY DIELECTRICS
C     FOR PARTICULAR COMPONENTS OF FIELDS AS DETERMINED BY XXX
C
C     IF IDONE (10,10,10) = 3 THEN THE USER MUST SPECIFY AN EPSILON, MU
C     AND SIGMA FOR MATERIAL TYPE 3.  THAT IS, EPS(3)=EPSILON FOR
C     MATERIAL TYPE 3 AND SIGMA(3)= CONDUCTIVITY FOR MATERIAL TYPE 3.
C     ALL PARAMETERS ARE DEFINED IN MKS UNITS.
C
C
C     GENERATE MULTIPLICATIVE CONSTANTS FOR FIELD UPDATE EQUATIONS
C
C     FREE SPACE
C
      DTEDX=DT/(EPS0*DELX)
      DTEDY=DT/(EPS0*DELY)
      DTEDZ=DT/(EPS0*DELZ)
      DTMDX=DT/(XMU0*DELX)
      DTMDY=DT/(XMU0*DELY)
      DTMDZ=DT/(XMU0*DELZ)
C
C     LOSSY DIELECTRICS
C
      DO 20 I=2,9
	ESB(I)=(2.*EPS(I)-SIGMA(I)*DT)/(2.*EPS(I)+SIGMA(I) *DT)
	ECRLX(I)=2.*DT/((2.*EPS(I)+SIGMA(I)*DT)*DELX)
	ECRLY(I)=2.*DT/((2.*EPS(I)+SIGMA(I)*DT)*DELY)
	ECRLZ(I)=2.*DT/((2.*EPS(I)+SIGMA(I)*DT)*DELZ)
 20   CONTINUE

C***** POINTS WHERE SAR IS CALCULATED ********

       MSRXB(1)=22+NPML  
       MSRXE(1)=22+NPML
       MSRYB(1)=22+NPML
       MSRYE(1)=22+NPML
       MSRZB(1)=20+NPML
       MSRZE(1)=20+NPML

       MSRXB(2)=26+NPML
       MSRXE(2)=26+NPML
       MSRYB(2)=22+NPML
       MSRYE(2)=22+NPML
       MSRZB(2)=20+NPML
       MSRZE(2)=20+NPML

C***** ASSIGNING DEFAULT OBSERVATION POINTS ********

       NOX(1)=NOX1
       NOX(2)=NOX2
       NOX(3)=NOX3

       NOY(1)=NOY1
       NOY(2)=NOY2
       NOY(3)=NOY3

       NOZ(1)=NOZ1
       NOZ(2)=NOZ2
       NOZ(3)=NOZ3

       DO I=1,3
        IF(IOBS(I).EQ.0.AND.JOBS(I).EQ.0.AND.KOBS(I).EQ.0) THEN
         IOBS(I)=NOX(I)
         JOBS(I)=NOY(I)
         KOBS(I)=NOZ(I)
        ENDIF
       ENDDO
      
      RETURN
      END
C     ********************************************************
      SUBROUTINE PMLSETUP
      INCLUDE 'FDSAR.PAR'
       
       SIGMAXE(1)=ESIGMAM
       SIGMAXE(2)=ESIGMAM
       SIGMAXE(3)=ESIGMAM
       SIGMAXE(4)=ESIGMAM
       SIGMAXE(5)=ESIGMAM
       SIGMAXE(6)=ESIGMAM
       SIGMAXE(7)=ESIGMAM
       SIGMAXE(8)=ESIGMAM
       SIGMAXE(9)=ESIGMAM
       SIGMAXE(10)=ESIGMAM
       SIGMAXE(11)=ESIGMAM
       SIGMAXE(12)=ESIGMAM
C
       SIGMAXE(13)=0.
       SIGMAXE(14)=0.
       SIGMAXE(15)=0.
       SIGMAXE(16)=0.
C
       SIGMAXE(17)=ESIGMAM
       SIGMAXE(18)=ESIGMAM
       SIGMAXE(19)=ESIGMAM
       SIGMAXE(20)=ESIGMAM
C
       SIGMAXE(21)=0.
       SIGMAXE(22)=0.
       SIGMAXE(23)=ESIGMAM
       SIGMAXE(24)=ESIGMAM
       SIGMAXE(25)=0.
       SIGMAXE(26)=0.
       SIGMAXE(27)=0.
       
C
       SIGMAYE(1)=ESIGMAM
       SIGMAYE(2)=ESIGMAM
       SIGMAYE(3)=ESIGMAM
       SIGMAYE(4)=ESIGMAM
       SIGMAYE(5)=ESIGMAM
       SIGMAYE(6)=ESIGMAM
       SIGMAYE(7)=ESIGMAM
       SIGMAYE(8)=ESIGMAM
C            
       SIGMAYE(9)=0.
       SIGMAYE(10)=0.
       SIGMAYE(11)=0.
       SIGMAYE(12)=0.
C
       SIGMAYE(13)=ESIGMAM
       SIGMAYE(14)=ESIGMAM
       SIGMAYE(15)=ESIGMAM
       SIGMAYE(16)=ESIGMAM
C
       SIGMAYE(17)=ESIGMAM
       SIGMAYE(18)=ESIGMAM
       SIGMAYE(19)=ESIGMAM
       SIGMAYE(20)=ESIGMAM
C
       SIGMAYE(21)=0.
       SIGMAYE(22)=0.
       SIGMAYE(23)=0.
       SIGMAYE(24)=0.
       SIGMAYE(25)=ESIGMAM
       SIGMAYE(26)=ESIGMAM
       SIGMAYE(27)=0.
       
C
       SIGMAZE(1)=ESIGMAM
       SIGMAZE(2)=ESIGMAM
       SIGMAZE(3)=ESIGMAM
       SIGMAZE(4)=ESIGMAM
       SIGMAZE(5)=ESIGMAM
       SIGMAZE(6)=ESIGMAM
       SIGMAZE(7)=ESIGMAM
       SIGMAZE(8)=ESIGMAM
C            
       SIGMAZE(9)=ESIGMAM
       SIGMAZE(10)=ESIGMAM
       SIGMAZE(11)=ESIGMAM
       SIGMAZE(12)=ESIGMAM
C
       SIGMAZE(13)=ESIGMAM
       SIGMAZE(14)=ESIGMAM
       SIGMAZE(15)=ESIGMAM
       SIGMAZE(16)=ESIGMAM
C
       SIGMAZE(17)=0.
       SIGMAZE(18)=0.
       SIGMAZE(19)=0.
       SIGMAZE(20)=0.
C
       SIGMAZE(21)=ESIGMAM
       SIGMAZE(22)=ESIGMAM
       SIGMAZE(23)=0.
       SIGMAZE(24)=0.
       SIGMAZE(25)=0.
       SIGMAZE(26)=0.
       SIGMAZE(27)=0.
C
       SIGMAXH(1)=HSIGMAM
       SIGMAXH(2)=HSIGMAM
       SIGMAXH(3)=HSIGMAM
       SIGMAXH(4)=HSIGMAM
       SIGMAXH(5)=HSIGMAM
       SIGMAXH(6)=HSIGMAM
       SIGMAXH(7)=HSIGMAM
       SIGMAXH(8)=HSIGMAM
C
       SIGMAXH(9)=HSIGMAM
       SIGMAXH(10)=HSIGMAM
       SIGMAXH(11)=HSIGMAM
       SIGMAXH(12)=HSIGMAM
C
       SIGMAXH(13)=0.
       SIGMAXH(14)=0.
       SIGMAXH(15)=0.
       SIGMAXH(16)=0.
C
       SIGMAXH(17)=HSIGMAM
       SIGMAXH(18)=HSIGMAM
       SIGMAXH(19)=HSIGMAM
       SIGMAXH(20)=HSIGMAM
C
       SIGMAXH(21)=0.
       SIGMAXH(22)=0.
       SIGMAXH(23)=HSIGMAM
       SIGMAXH(24)=HSIGMAM
       SIGMAXH(25)=0.
       SIGMAXH(26)=0.
       SIGMAXH(27)=0.
C
       SIGMAYH(1)=HSIGMAM
       SIGMAYH(2)=HSIGMAM
       SIGMAYH(3)=HSIGMAM
       SIGMAYH(4)=HSIGMAM
       SIGMAYH(5)=HSIGMAM
       SIGMAYH(6)=HSIGMAM
       SIGMAYH(7)=HSIGMAM
       SIGMAYH(8)=HSIGMAM
C            
       SIGMAYH(9)=0.
       SIGMAYH(10)=0.
       SIGMAYH(11)=0.
       SIGMAYH(12)=0.
C      
       SIGMAYH(13)=HSIGMAM
       SIGMAYH(14)=HSIGMAM
       SIGMAYH(15)=HSIGMAM
       SIGMAYH(16)=HSIGMAM
C
       SIGMAYH(17)=HSIGMAM
       SIGMAYH(18)=HSIGMAM
       SIGMAYH(19)=HSIGMAM
       SIGMAYH(20)=HSIGMAM
C      
       SIGMAYH(21)=0.
       SIGMAYH(22)=0.
       SIGMAYH(23)=0.
       SIGMAYH(24)=0.
       SIGMAYH(25)=HSIGMAM
       SIGMAYH(26)=HSIGMAM
       SIGMAYH(27)=0.
C
       SIGMAZH(1)=HSIGMAM
       SIGMAZH(2)=HSIGMAM
       SIGMAZH(3)=HSIGMAM
       SIGMAZH(4)=HSIGMAM
       SIGMAZH(5)=HSIGMAM
       SIGMAZH(6)=HSIGMAM
       SIGMAZH(7)=HSIGMAM
       SIGMAZH(8)=HSIGMAM
C            
       SIGMAZH(9)=HSIGMAM
       SIGMAZH(10)=HSIGMAM
       SIGMAZH(11)=HSIGMAM
       SIGMAZH(12)=HSIGMAM
C      
       SIGMAZH(13)=HSIGMAM
       SIGMAZH(14)=HSIGMAM
       SIGMAZH(15)=HSIGMAM
       SIGMAZH(16)=HSIGMAM
C
       SIGMAZH(17)=0.
       SIGMAZH(18)=0.
       SIGMAZH(19)=0.
       SIGMAZH(20)=0.
C      
       SIGMAZH(21)=HSIGMAM
       SIGMAZH(22)=HSIGMAM
       SIGMAZH(23)=0.
       SIGMAZH(24)=0.
       SIGMAZH(25)=0.
       SIGMAZH(26)=0.
       SIGMAZH(27)=0.

      RETURN
      END
C     ********************************************************
   
      SUBROUTINE EXFLD
      INCLUDE 'FDSAR.PAR'
C
      DO 30 K=2,NZ1
        KK=K
	DO 20 J=2,NY1
          JJ=J
	  DO 10 I=1,NX1
          II=I
C
C         FDTD BOLGESI 
C
          IF ((I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYBP1.AND.J.LT.NYS.
     $                 AND.K.GT.NZBP1.AND.K.LT.NZS).OR.NTER.EQ.0) THEN

C           DETERMINE MATERIAL TYPE
	    IF(IDONE(I,J,K).EQ.0) GO TO 100
	    IF(IDONE(I,J,K).EQ.1) GO TO 200
	    GO TO 300

C           FREE SPACE
 100        EX(I,J,K)=EX(I,J,K)+(HZ(I,J,K)-HZ(I,J-1,K))*DTEDY
     $                           -(HY(I,J,K)-HY(I,J,K-1))*DTEDZ
	    GO TO 10

C           PERFECT CONDUCTOR
 200        EX(I,J,K)=0.0
	    GO TO 10

C           LOSSY DIELECTRIC
 300        EX(I,J,K)=EX(I,J,K)*ESB(IDONE(I,J,K))
     $      +(HZ(I,J,K)-HZ(I,J-1,K))*ECRLY(IDONE(I,J,K))
     $      -(HY(I,J,K)-HY(I,J,K-1))*ECRLZ(IDONE(I,J,K))

          ELSE
C
C         PML BOLGESI 
C
            CALL PMLEX(II,JJ,KK)
            
          ENDIF
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE

      RETURN
      END
C     ********************************************************
      SUBROUTINE EYFLD
      INCLUDE 'FDSAR.PAR'
C
      DO 30 K=2,NZ1
        KK=K
	DO 20 J=1,NY1
          JJ=J
	  DO 10 I=2,NX1
          II=I	  
C
C         FDTD BOLGESI
C
          IF ((I.GT.NXBP1.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS.
     $                AND.K.GT.NZBP1.AND.K.LT.NZS).OR.NTER.EQ.0) THEN


C           DETERMINE MATERIAL TYPE
	    IF(IDTWO(I,J,K).EQ.0) GO TO 100
	    IF(IDTWO(I,J,K).EQ.1) GO TO 200
	    GO TO 300

C           FREE SPACE
 100        EY(I,J,K)=EY(I,J,K)+(HX(I,J,K)-HX(I,J,K-1))*DTEDZ
     $                         -(HZ(I,J,K)-HZ(I-1,J,K))*DTEDX

	    GO TO 10

C           PERFECT CONDUCTOR
 200        EY(I,J,K)=0.0
	    GO TO 10

C           LOSSY DIELECTRIC
 300        EY(I,J,K)=EY(I,J,K)*ESB(IDTWO(I,J,K))
     $      +(HX(I,J,K)-HX(I,J,K-1))*ECRLZ(IDTWO(I,J,K))
     $      -(HZ(I,J,K)-HZ(I-1,J,K))*ECRLX(IDTWO(I,J,K))


          ELSE
C
C         PML BOLGESI 
C
            CALL PMLEY(II,JJ,KK)
	  ENDIF
  
  10      CONTINUE
  20    CONTINUE
  30  CONTINUE
C******************************
C  ANTEN BESLEME UYGULANIYOR  *
C******************************
        IF(NPOL.EQ.2) THEN
          SS=AMP*SIN(2.*PI*F0*T)
          IF(NTIME.LE.NP) THEN
           SS=SS*.5*(1.-COS(PI*NTIME/NP))
          ENDIF
          EY(IB,JB,KB)=EY(IB,JB,KB)+SS/4
          EY(IB+1,JB,KB)=EY(IB+1,JB,KB)+SS/4
          EY(IB+1,JB,KB+1)=EY(IB+1,JB,KB+1)+SS/4
          EY(IB,JB,KB+1)=EY(IB,JB,KB+1)+SS/4
          WRITE(70,*) T*1.E9, SS
        END IF

      RETURN
      END
C     ********************************************************
      SUBROUTINE EZFLD
      INCLUDE 'FDSAR.PAR'
C
      DO 30 K=1,NZ1
        KK=K
	DO 20 J=2,NY1
          JJ=J
	  DO 10 I=2,NX1
          II=I
C
C         FDTD BOLGESI
C
          IF ((I.GT.NXBP1.AND.I.LT.NXS.AND.J.GT.NYBP1.AND.J.LT.NYS.
     $               AND.K.GT.NZB.AND.K.LT.NZS).OR.NTER.EQ.0) THEN


C           DETERMINE MATERIAL TYPE
	    IF(IDTHRE(I,J,K).EQ.0) GO TO 100
	    IF(IDTHRE(I,J,K).EQ.1) GO TO 200
	    GO TO 300
C
C           FREE SPACE
 100        EZ(I,J,K)=EZ(I,J,K)+(HY(I,J,K)-HY(I-1,J,K))*DTEDX
     $                           -(HX(I,J,K)-HX(I,J-1,K))*DTEDY
	    GO TO 10

C           PERFECT CONDUCTOR
 200        EZ(I,J,K)=0.0
	    GO TO 10

C           LOSSY DIELECTRIC
 300        EZ(I,J,K)=EZ(I,J,K)*ESB(IDTHRE(I,J,K))
     $      +(HY(I,J,K)-HY(I-1,J,K))*ECRLX(IDTHRE(I,J,K))
     $      -(HX(I,J,K)-HX(I,J-1,K))*ECRLY(IDTHRE(I,J,K))

          ELSE
C
C         PML BOLGESI 
C
            CALL PMLEZ(II,JJ,KK)

          ENDIF
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C******************************
C  ANTEN BESLEME UYGULANIYOR  *
C******************************
          IF(NPOL.EQ.1) THEN
           SS=AMP*SIN(2.*PI*F0*T)
           IF(NTIME.LE.NP) THEN
            SS=SS*.5*(1.-COS(PI*NTIME/NP))
           ENDIF
c --------------------------------------
c          BAND=0.9*F0
c          ALPHA=3.3*BAND*BAND
c          SHIFT=4.0/SQRT(ALPHA)
c          SS=-AMP*(T-SHIFT)*EXP(-ALPHA*(T-SHIFT)**2)
c --------------------------------------
           EZ(IB,JB,KB)=EZ(IB,JB,KB)+SS/4
           EZ(IB+1,JB,KB)=EZ(IB+1,JB,KB)+SS/4
           EZ(IB+1,JB+1,KB)=EZ(IB+1,JB+1,KB)+SS/4
           EZ(IB,JB+1,KB)=EZ(IB,JB+1,KB)+SS/4
           WRITE(70,*) T*1.E9, SS
          END IF
      RETURN
      END

C     *****************************************************************
      SUBROUTINE HXFLD
      INCLUDE 'FDSAR.PAR'
C
      DO 30 K=1,NZ1
        KK=K
	DO 20 J=1,NY1
          JJ=J
	  DO 10 I=2,NX1
          II=I
C
C         FDTD BOLGESI
C
          IF ((I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYSM1.
     $              AND.K.GT.NZB.AND.K.LT.NZSM1).OR.NTER.EQ.0) THEN

	    HX(I,J,K)=HX(I,J,K)-(EZ(I,J+1,K)-EZ(I,J,K))*DTMDY
     $                           +(EY(I,J,K+1)-EY(I,J,K))*DTMDZ
          ELSE
C
C         PML BOLGESI 
C
            CALL PMLHX(II,JJ,KK)

	  ENDIF
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C
      RETURN
      END
C     ********************************************************
      SUBROUTINE HYFLD
      INCLUDE 'FDSAR.PAR'
C
      DO 30 K=1,NZ1
        KK=K
	DO 20 J=2,NY1
          JJ=J
	  DO 10 I=1,NX1
            II=I
C
C         FDTD BOLGESI
C
          IF ((I.GT.NXB.AND.I.LT.NXSM1.AND.J.GT.NYB.AND.J.LT.NYS.
     $              AND.K.GT.NZB.AND.K.LT.NZSM1).OR.NTER.EQ.0) THEN


	    HY(I,J,K)=HY(I,J,K)-(EX(I,J,K+1)-EX(I,J,K))*DTMDZ
     $                           +(EZ(I+1,J,K)-EZ(I,J,K))*DTMDX
          ELSE
C
C         PML BOLGESI 
C
            CALL PMLHY(II,JJ,KK)

          ENDIF
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C
      RETURN
      END
C     ********************************************************
      SUBROUTINE HZFLD
      INCLUDE 'FDSAR.PAR'
C
      DO 30 K=2,NZ1
        KK=K
	DO 20 J=1,NY1
          JJ=J
	  DO 10 I=1,NX1
            II=I
C
C         FDTD BOLGESI
C
          IF ((I.GT.NXB.AND.I.LT.NXSM1.AND.J.GT.NYB.AND.J.LT.NYSM1.
     $                AND.K.GT.NZB.AND.K.LT.NZS).OR.NTER.EQ.0) THEN

	    HZ(I,J,K)=HZ(I,J,K)-(EY(I+1,J,K)-EY(I,J,K))*DTMDX
     $                           +(EX(I,J+1,K)-EX(I,J,K))*DTMDY
          ELSE
C
C         PML BOLGESI 
C
            CALL PMLHZ(II,JJ,KK)

	  ENDIF
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C
      RETURN
      END
C     ***************************************************************
      SUBROUTINE ZERO
      INCLUDE 'FDSAR.PAR'
C
      T=0.0
      DO 30 K=1,NZ
	DO 20 J=1,NY
	  DO 10 I=1,NX
	    EX(I,J,K)=0.0
	    EY(I,J,K)=0.0
	    EZ(I,J,K)=0.0
	    HX(I,J,K)=0.0
	    HY(I,J,K)=0.0
	    HZ(I,J,K)=0.0
	    EXY(I,J,K)=0.0
	    EYX(I,J,K)=0.0
	    EZX(I,J,K)=0.0
	    EXZ(I,J,K)=0.0
	    EYZ(I,J,K)=0.0
	    EZY(I,J,K)=0.0
	    HXY(I,J,K)=0.0
	    HYX(I,J,K)=0.0
	    HZX(I,J,K)=0.0
	    HXZ(I,J,K)=0.0
	    HYZ(I,J,K)=0.0
	    HZY(I,J,K)=0.0
	    IDONE(I,J,K)=0.0
	    IDTWO(I,J,K)=0.0
	    IDTHRE(I,J,K)=0.0
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C*************************************************
      DO 130 L=1,9
        ESB(L)=0.0
	ECRLX(L)=0.0
	ECRLY(L)=0.0
	ECRLZ(L)=0.0
 130  CONTINUE

      DO 140 I=1,9
	EPS(I)=EPS0
        EPSP(I)=EPS0
	SIGMA(I)=0.0
        DENSTY(I)=1000.0
 140  CONTINUE

      PABS=0.0


      RETURN
      END
C     ********************************************************

      SUBROUTINE PMLEX(I,J,K)
      INCLUDE 'FDSAR.PAR'
      
      XJ=1*J
      XK=1*K
      EPSF=1. 
      IF(J.LE.NYB) THEN
        ESIGMAY=SIGMAYE(IDPML(I,J,K))*EPSF*((XNPML-XJ+1.)/XNPML)**2.
      ELSE
        ESIGMAY=SIGMAYE(IDPML(I,J,K))*EPSF*((XJ-YN+XNPML)/XNPML)**2.
      ENDIF
      
      IF(K.LE.NZB) THEN
        ESIGMAZ=SIGMAZE(IDPML(I,J,K))*EPSF*((XNPML-XK+1.)/XNPML)**2.
      ELSE
        ESIGMAZ=SIGMAZE(IDPML(I,J,K))*EPSF*((XK-ZN+XNPML)/XNPML)**2.
      ENDIF

      IF (ESIGMAY.LE.0.) THEN
       DTESY=1.
       DTESDY=DT/(DELY*EPSP(IDONE(I,J,K)+1))
      ELSE
       DTESY=EXP(-(ESIGMAY*DT)/EPSP(IDONE(I,J,K)+1))
       DTESDY=(1.-DTESY)/(ESIGMAY*DELY)
      ENDIF

      IF (ESIGMAZ.LE.0.) THEN
       DTESZ=1.
       DTESDZ=DT/(DELZ*EPSP(IDONE(I,J,K)+1))
      ELSE
       DTESZ=EXP(-(ESIGMAZ*DT)/EPSP(IDONE(I,J,K)+1))
       DTESDZ=(1.-DTESZ)/(ESIGMAZ*DELZ)
      ENDIF
C
C         PML INTERFACE
C
          IF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYBP1
     $                              .AND.K.GT.NZBP1.AND.K.LT.NZS) THEN

            IF (IDONE(I,J,K).EQ.0) THEN
	    
             EX(I,J,K)=EX(I,J,K)+(HZ(I,J,K)
     $               -HZX(I,J-1,K)-HZY(I,J-1,K))*DTEDY
     $               -(HY(I,J,K)-HY(I,J,K-1))*DTEDZ
	    ELSEIF (IDONE(I,J,K).EQ.1) THEN  
	     EX(I,J,K)=0.0
	    ELSE
	     EX(I,J,K)=EX(I,J,K)*ESB(IDONE(I,J,K))
     $      +(HZ(I,J,K)-HZX(I,J-1,K)-HZY(I,J-1,K))
     $      *ECRLY(IDONE(I,J,K))
     $      -(HY(I,J,K)-HY(I,J,K-1))*ECRLZ(IDONE(I,J,K))

	    ENDIF
	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYBP1.AND.J.LT.NYS
     $                                         .AND.K.EQ.NZBP1) THEN

	    IF (IDONE(I,J,K).EQ.0) THEN
	    
	     EX(I,J,K)=EX(I,J,K)+(HZ(I,J,K)-HZ(I,J-1,K))*DTEDY
     $               -(HY(I,J,K)-HYX(I,J,K-1)-HYZ(I,J,K-1))*DTEDZ
	    ELSEIF (IDONE(I,J,K).EQ.1) THEN  
	     EX(I,J,K)=0.0
	    ELSE
	     EX(I,J,K)=EX(I,J,K)*ESB(IDONE(I,J,K))
     $      +(HZ(I,J,K)-HZ(I,J-1,K))
     $      *ECRLY(IDONE(I,J,K))
     $      -(HY(I,J,K)-HYX(I,J,K-1)-HYZ(I,J,K-1))*ECRLZ(IDONE(I,J,K))
	    ENDIF


	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
                 
	   IF(IDONE(I,J,K).EQ.1) THEN
	    EXY(I,J,K)=0.0
	    EXZ(I,J,K)=0.0
	   ELSE
	    EXY(I,J,K)=EXY(I,J,K)*DTESY+(HZX(I,J,K)+HZY(I,J,K)
     $                           -HZ(I,J-1,K))*DTESDY
	    EXZ(I,J,K)=EXZ(I,J,K)*DTESZ-(HYX(I,J,K)+HYZ(I,J,K)
     $                           -HYX(I,J,K-1)-HYZ(I,J,K-1))*DTESDZ
	   ENDIF

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                         .AND.K.EQ.NZS) THEN
	   IF(IDONE(I,J,K).EQ.1) THEN
	    EXY(I,J,K)=0.0
	    EXZ(I,J,K)=0.0

	   ELSE
	   
	    EXZ(I,J,K)=EXZ(I,J,K)*DTESZ-(HYX(I,J,K)+HYZ(I,J,K)
     $                           -HY(I,J,K-1))*DTESDZ
	    EXY(I,J,K)=EXY(I,J,K)*DTESY+(HZX(I,J,K)+HZY(I,J,K)
     $                           -HZX(I,J-1,K)-HZY(I,J-1,K))*DTESDY
	   ENDIF

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYBP1
     $                              .AND.K.EQ.NZBP1) THEN
	    IF (IDONE(I,J,K).EQ.0) THEN
	    
	     EX(I,J,K)=EX(I,J,K)+(HZ(I,J,K)
     $     -HZX(I,J-1,K)-HZY(I,J-1,K))*DTEDY
     $    -(HY(I,J,K)-HYX(I,J,K-1)-HYZ(I,J,K-1))*DTEDZ
	    
	    ELSEIF (IDONE(I,J,K).EQ.1) THEN  
	     EX(I,J,K)=0.0
	    
	    ELSE
	     EX(I,J,K)=EX(I,J,K)*ESB(IDONE(I,J,K))
     $      +(HZ(I,J,K)-HZX(I,J-1,K)-HZY(I,J-1,K))
     $      *ECRLY(IDONE(I,J,K))
     $      -(HY(I,J,K)-HYX(I,J,K-1)-HYZ(I,J,K-1))*ECRLZ(IDONE(I,J,K))

	    ENDIF
C
C         PML
C
          ELSE
      
            IF(IDONE(I,J,K).EQ.1) THEN
              EXY(I,J,K)=0.0
              EXZ(I,J,K)=0.0

            ELSE
              EXY(I,J,K)=EXY(I,J,K)*DTESY+(HZX(I,J,K)+HZY(I,J,K)
     $              -HZX(I,J-1,K)-HZY(I,J-1,K))*DTESDY
              EXZ(I,J,K)=EXZ(I,J,K)*DTESZ-(HYX(I,J,K)+HYZ(I,J,K)
     $              -HYX(I,J,K-1)-HYZ(I,J,K-1))*DTESDZ
      
            ENDIF

          ENDIF
      RETURN
      END

C     ********************************************************
      SUBROUTINE PMLEY(I,J,K)
      INCLUDE 'FDSAR.PAR'
      
      XI=1*I
      XK=1*K

      EPSF=1. 

      IF(I.LE.NXB) THEN
        ESIGMAX=SIGMAXE(IDPML(I,J,K))*EPSF*((XNPML-XI+1.)/XNPML)**2.
      ELSE
        ESIGMAX=SIGMAXE(IDPML(I,J,K))*EPSF*((XI-XN+XNPML)/XNPML)**2.
      ENDIF
      IF(K.LE.NZB) THEN
        ESIGMAZ=SIGMAZE(IDPML(I,J,K))*EPSF*((XNPML-XK+1.)/XNPML)**2.
      ELSE
        ESIGMAZ=SIGMAZE(IDPML(I,J,K))*EPSF*((XK-ZN+XNPML)/XNPML)**2.
      ENDIF

      IF (ESIGMAZ.LE.0.) THEN
       DTESZ=1.
       DTESDZ=DT/(DELZ*EPSP(IDTWO(I,J,K)+1))
      ELSE
       DTESZ=EXP(-(ESIGMAZ*DT)/EPSP(IDTWO(I,J,K)+1))
       DTESDZ=(1.-DTESZ)/(ESIGMAZ*DELZ)
      ENDIF

      IF (ESIGMAX.LE.0.) THEN
       DTESX=1.
       DTESDX=DT/(DELX*EPSP(IDTWO(I,J,K)+1))
      ELSE
       DTESX=EXP(-(ESIGMAX*DT)/EPSP(IDTWO(I,J,K)+1))
       DTESDX=(1.-DTESX)/(ESIGMAX*DELX)
      ENDIF
C
C          PML INTERFACE
C
          IF (I.EQ.NXBP1.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZBP1.AND.K.LT.NZS) THEN

	    IF (IDTWO(I,J,K).EQ.0) THEN
	     EY(I,J,K)=EY(I,J,K)+(HX(I,J,K)-HX(I,J,K-1))*DTEDZ
     $      -(HZ(I,J,K)-HZX(I-1,J,K)-HZY(I-1,J,K))
     $      *DTEDX
	    ELSEIF (IDTWO(I,J,K).EQ.1) THEN
	     EY(I,J,K)=0.0
	    ELSE
	    
	    EY(I,J,K)=EY(I,J,K)*ESB(IDTWO(I,J,K))
     $      +(HX(I,J,K)-HX(I,J,K-1))*ECRLZ(IDTWO(I,J,K))
     $      -(HZ(I,J,K)-HZX(I-1,J,K)-HZY(I-1,J,K))*ECRLX(IDTWO(I,J,K))

	    ENDIF


	  ELSEIF (I.GT.NXBP1.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZBP1) THEN


	    IF (IDTWO(I,J,K).EQ.0) THEN
	     EY(I,J,K)=EY(I,J,K)+(HX(I,J,K)
     $              -HXY(I,J,K-1)-HXZ(I,J,K-1))*DTEDZ
     $            -(HZ(I,J,K)-HZ(I-1,J,K))*DTEDX
	    ELSEIF (IDTWO(I,J,K).EQ.1) THEN
	     EY(I,J,K)=0.0
	    ELSE
	    
	    EY(I,J,K)=EY(I,J,K)*ESB(IDTWO(I,J,K))
     $      +(HX(I,J,K)-HXY(I,J,K-1)-HXZ(I,J,K-1))*ECRLZ(IDTWO(I,J,K))
     $      -(HZ(I,J,K)-HZ(I-1,J,K))*ECRLX(IDTWO(I,J,K))

	    ENDIF


	  ELSEIF (I.EQ.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
	   IF(IDTWO(I,J,K).EQ.1) THEN
	    EYX(I,J,K)=0.0
	    EYZ(I,J,K)=0.0

	   ELSE

	    EYX(I,J,K)=EYX(I,J,K)*DTESX-(HZX(I,J,K)+HZY(I,J,K)
     $                           -HZ(I-1,J,K))*DTESDX
	    EYZ(I,J,K)=EYZ(I,J,K)*DTESZ+(HXY(I,J,K)+HXZ(I,J,K)
     $                           -HXY(I,J,K-1)-HXZ(I,J,K-1))*DTESDZ
	   ENDIF

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZS) THEN
	   
	   IF(IDTWO(I,J,K).EQ.1) THEN
	    EYX(I,J,K)=0.0
	    EYZ(I,J,K)=0.0

	   ELSE
	   
	    EYZ(I,J,K)=EYZ(I,J,K)*DTESZ+(HXY(I,J,K)+HXZ(I,J,K)
     $                           -HX(I,J,K-1))*DTESDZ
	    EYX(I,J,K)=EYX(I,J,K)*DTESX-(HZX(I,J,K)+HZY(I,J,K)
     $                           -HZX(I-1,J,K)-HZY(I-1,J,K))*DTESDX
	   ENDIF

	  ELSEIF (I.EQ.NXBP1.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZBP1) THEN

	    IF (IDTWO(I,J,K).EQ.0) THEN
	     EY(I,J,K)=EY(I,J,K)+(HX(I,J,K)
     $     -HXY(I,J,K-1)-HXZ(I,J,K-1))*DTEDZ
     $     -(HZ(I,J,K)-HZX(I-1,J,K)-HZY(I-1,J,K))*DTEDX

	    
	    ELSEIF (IDTWO(I,J,K).EQ.1) THEN
	     EY(I,J,K)=0.0
	    ELSE
	    
	    EY(I,J,K)=EY(I,J,K)*ESB(IDTWO(I,J,K))
     $      +(HX(I,J,K)-HXY(I,J,K-1)-HXZ(I,J,K-1))*ECRLZ(IDTWO(I,J,K))
     $      -(HZ(I,J,K)-HZX(I-1,J,K)-HZY(I-1,J,K))*ECRLX(IDTWO(I,J,K))

	    ENDIF
C
C         PML
C
          ELSE
          
            IF(IDTWO(I,J,K).EQ.1) THEN
              EYX(I,J,K)=0.0
              EYZ(I,J,K)=0.0

            ELSE

              EYZ(I,J,K)=EYZ(I,J,K)*DTESZ+(HXY(I,J,K)+HXZ(I,J,K)
     $              -HXY(I,J,K-1)-HXZ(I,J,K-1))*DTESDZ
              EYX(I,J,K)=EYX(I,J,K)*DTESX-(HZX(I,J,K)+HZY(I,J,K)
     $              -HZX(I-1,J,K)-HZY(I-1,J,K))*DTESDX

           ENDIF
          ENDIF

      RETURN
      END

C     ********************************************************
      SUBROUTINE PMLEZ(I,J,K)
      INCLUDE 'FDSAR.PAR'

      XJ=1*J
      XI=1*I
     
      EPSF=1. 
      IF(J.LE.NYB) THEN
        ESIGMAY=SIGMAYE(IDPML(I,J,K))*EPSF*((XNPML-XJ+1.)/XNPML)**2.
      ELSE
        ESIGMAY=SIGMAYE(IDPML(I,J,K))*EPSF*((XJ-YN+XNPML)/XNPML)**2.
      ENDIF

      IF(I.LE.NXB) THEN
        ESIGMAX=SIGMAXE(IDPML(I,J,K))*EPSF*((XNPML-XI+1.)/XNPML)**2.
      ELSE
        ESIGMAX=SIGMAXE(IDPML(I,J,K))*EPSF*((XI-XN+XNPML)/XNPML)**2.
      ENDIF

      IF (ESIGMAY.LE.0.) THEN
       DTESY=1.
       DTESDY=DT/(DELY*EPSP(IDTHRE(I,J,K)+1))
      ELSE
       DTESY=EXP(-(ESIGMAY*DT)/EPSP(IDTHRE(I,J,K)+1))
       DTESDY=(1.-DTESY)/(ESIGMAY*DELY)
      ENDIF

      IF (ESIGMAX.LE.0.) THEN
       DTESX=1.
       DTESDX=DT/(DELX*EPSP(IDTHRE(I,J,K)+1))
      ELSE
       DTESX=EXP(-(ESIGMAX*DT)/EPSP(IDTHRE(I,J,K)+1))
       DTESDX=(1.-DTESX)/(ESIGMAX*DELX)
      ENDIF
C
C          PML INTERFACE
C
         IF (I.EQ.NXBP1.AND.J.GT.NYBP1.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	    IF (IDTHRE(I,J,K).EQ.0) THEN
	     EZ(I,J,K)=EZ(I,J,K)+(HY(I,J,K)-HYX(I-1,J,K)
     $               -HYZ(I-1,J,K))*DTEDX
     $               -(HX(I,J,K)-HX(I,J-1,K))*DTEDY
	    
	    ELSEIF (IDTHRE(I,J,K).EQ.1) THEN
	     EZ(I,J,K)=0.0
	    
	    ELSE
	     EZ(I,J,K)=EZ(I,J,K)*ESB(IDTHRE(I,J,K))
     $      +(HY(I,J,K)-HYX(I-1,J,K)-HYZ(I-1,J,K))*ECRLX(IDTHRE(I,J,K))
     $      -(HX(I,J,K)-HX(I,J-1,K))
     $      *ECRLY(IDTHRE(I,J,K))
	    ENDIF


	  ELSEIF (I.GT.NXBP1.AND.I.LT.NXS.AND.J.EQ.NYBP1
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	    IF (IDTHRE(I,J,K).EQ.0) THEN
	     EZ(I,J,K)=EZ(I,J,K)+(HY(I,J,K)
     $                -HY(I-1,J,K))*DTEDX
     $                -(HX(I,J,K)-HXY(I,J-1,K)-HXZ(I,J-1,K))*DTEDY
	    
	    ELSEIF (IDTHRE(I,J,K).EQ.1) THEN
	     EZ(I,J,K)=0.0
	    
	    ELSE
	     EZ(I,J,K)=EZ(I,J,K)*ESB(IDTHRE(I,J,K))
     $      +(HY(I,J,K)-HY(I-1,J,K))*ECRLX(IDTHRE(I,J,K))
     $      -(HX(I,J,K)-HXY(I,J-1,K)-HXZ(I,J-1,K))
     $      *ECRLY(IDTHRE(I,J,K))
	    ENDIF
	    
	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
	   IF(IDTHRE(I,J,K).EQ.1) THEN
	    EZX(I,J,K)=0.0
	    EZY(I,J,K)=0.0

	   ELSE
		    
	    EZY(I,J,K)=EZY(I,J,K)*DTESY-(HXY(I,J,K)+HXZ(I,J,K)
     $                           -HX(I,J-1,K))*DTESDY
	    EZX(I,J,K)=EZX(I,J,K)*DTESX+(HYX(I,J,K)+HYZ(I,J,K)
     $                -HYX(I-1,J,K)-HYZ(I-1,J,K))*DTESDX
	   ENDIF


	  ELSEIF (I.EQ.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                               .AND.K.GT.NZB.AND.K.LT.NZS) THEN
	   
	   IF(IDTHRE(I,J,K).EQ.1) THEN
	    EZX(I,J,K)=0.0
	    EZY(I,J,K)=0.0

	   ELSE

	    EZX(I,J,K)=EZX(I,J,K)*DTESX+(HYX(I,J,K)+HYZ(I,J,K)
     $                           -HY(I-1,J,K))*DTESDX
	    EZY(I,J,K)=EZY(I,J,K)*DTESY-(HXY(I,J,K)+HXZ(I,J,K)
     $                -HXY(I,J-1,K)-HXZ(I,J-1,K))*DTESDY
	   ENDIF

	  ELSEIF (I.EQ.NXBP1.AND.J.EQ.NYBP1
     $                               .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	   IF(IDTHRE(I,J,K).EQ.0) THEN
	    EZ(I,J,K)=EZ(I,J,K)+
     $     (HY(I,J,K)-HYX(I-1,J,K)-HYZ(I-1,J,K))*DTEDX
     $     -(HX(I,J,K)-HXY(I,J-1,K)-HXZ(I,J-1,K))*DTEDY
	    
	    ELSEIF(IDTHRE(I,J,K).EQ.1) THEN
	     EZ(I,J,K)=0.0
	    ELSE
	     EZ(I,J,K)=EZ(I,J,K)*ESB(IDTHRE(I,J,K))
     $      +(HY(I,J,K)-HYX(I-1,J,K)-HYZ(I-1,J,K))*ECRLX(IDTHRE(I,J,K))
     $      -(HX(I,J,K)-HXY(I,J-1,K)-HXZ(I,J-1,K))
     $      *ECRLY(IDTHRE(I,J,K))
	    ENDIF
C
C         PML
C
	   ELSE
            
            IF(IDTHRE(I,J,K).EQ.1) THEN
              EZX(I,J,K)=0.0
              EZY(I,J,K)=0.0

            ELSE
	  
              EZX(I,J,K)=EZX(I,J,K)*DTESX+(HYX(I,J,K)+HYZ(I,J,K)
     $              -HYX(I-1,J,K)-HYZ(I-1,J,K))*DTESDX
              EZY(I,J,K)=EZY(I,J,K)*DTESY-(HXY(I,J,K)+HXZ(I,J,K)
     $              -HXY(I,J-1,K)-HXZ(I,J-1,K))*DTESDY

            ENDIF
           ENDIF

      RETURN
      END

C     ********************************************************
      SUBROUTINE PMLHX(I,J,K)
      INCLUDE 'FDSAR.PAR'
      
      XJ=1*J
      XK=1*K

      IF(J.LE.NYB) THEN
        HSIGMAY=SIGMAYH(IDPML(I,J,K))*((XNPML-XJ+0.5)/XNPML)**2.
      ELSE
        HSIGMAY=SIGMAYH(IDPML(I,J,K))*((XJ-YN+XNPML+0.5)/XNPML)**2.
      ENDIF
      IF(K.LE.NZB) THEN
        HSIGMAZ=SIGMAZH(IDPML(I,J,K))*((XNPML-XK+0.5)/XNPML)**2.
      ELSE
        HSIGMAZ=SIGMAZH(IDPML(I,J,K))*((XK-ZN+XNPML+0.5)/XNPML)**2.
      ENDIF

      IF (HSIGMAZ.LE.0.) THEN
       DTMSZ=1.
       DTMSDZ=DT/(DELZ*XMU0)
      ELSE
       DTMSZ=EXP(-(HSIGMAZ*DT)/XMU0)
       DTMSDZ=(1.-DTMSZ)/(HSIGMAZ*DELZ)
      ENDIF

      IF (HSIGMAY.LE.0.) THEN
       DTMSY=1.
       DTMSDY=DT/(DELY*XMU0)
      ELSE
       DTMSY=EXP(-(HSIGMAY*DT)/XMU0)
       DTMSDY=(1.-DTMSY)/(HSIGMAY*DELY)
      ENDIF
C
C          PML INTERFACE
C
          IF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYSM1
     $                              .AND.K.GT.NZB.AND.K.LT.NZSM1) THEN


	    HX(I,J,K)=HX(I,J,K)-(EZX(I,J+1,K)+EZY(I,J+1,K)
     $                -EZ(I,J,K))*DTMDY+(EY(I,J,K+1)-EY(I,J,K))*DTMDZ

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYSM1
     $                                          .AND.K.EQ.NZSM1) THEN

	    HX(I,J,K)=HX(I,J,K)-(EZ(I,J+1,K)-EZ(I,J,K))*DTMDY
     $                +(EYX(I,J,K+1)+EYZ(I,J,K+1)-EY(I,J,K))*DTMDZ

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYB
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
	   HXY(I,J,K)=HXY(I,J,K)*DTMSY-(EZ(I,J+1,K)
     $                           -EZX(I,J,K)-EZY(I,J,K))*DTMSDY
	   HXZ(I,J,K)=HXZ(I,J,K)*DTMSZ+(EYX(I,J,K+1)+EYZ(I,J,K+1)
     $                           -EYX(I,J,K)-EYZ(I,J,K))*DTMSDZ


	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZB) THEN

           HXZ(I,J,K)=HXZ(I,J,K)*DTMSZ+(EY(I,J,K+1)
     $                           -EYX(I,J,K)-EYZ(I,J,K))*DTMSDZ
	   HXY(I,J,K)=HXY(I,J,K)*DTMSY-(EZX(I,J+1,K)+EZY(I,J+1,K)
     $       -EZX(I,J,K)-EZY(I,J,K))*DTMSDY

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYSM1
     $                                          .AND.K.EQ.NZSM1) THEN

	    HX(I,J,K)=HX(I,J,K)
     $       -(EZX(I,J+1,K)+EZY(I,J+1,K)-EZ(I,J,K))*DTMDY
     $                +(EYX(I,J,K+1)+EYZ(I,J,K+1)-EY(I,J,K))*DTMDZ
C
C         PML
C
          ELSE

           HXY(I,J,K)=HXY(I,J,K)*DTMSY
     $              -(EZX(I,J+1,K)+EZY(I,J+1,K)
     $              -EZX(I,J,K)-EZY(I,J,K))*DTMSDY
           HXZ(I,J,K)=HXZ(I,J,K)*DTMSZ
     $              +(EYX(I,J,K+1)+EYZ(I,J,K+1)
     $              -EYX(I,J,K)-EYZ(I,J,K))*DTMSDZ

          ENDIF
      RETURN
      END

C     ********************************************************
      SUBROUTINE PMLHY(I,J,K)
      INCLUDE 'FDSAR.PAR'

      XI=1*I
      XK=1*K

      IF(I.LE.NXB) THEN
        HSIGMAX=SIGMAXH(IDPML(I,J,K))*((XNPML-XI+0.5)/XNPML)**2.
      ELSE
        HSIGMAX=SIGMAXH(IDPML(I,J,K))*((XI-XN+XNPML+0.5)/XNPML)**2.
      ENDIF
      IF(K.LE.NZB) THEN
        HSIGMAZ=SIGMAZH(IDPML(I,J,K))*((XNPML-XK+0.5)/XNPML)**2.
      ELSE
        HSIGMAZ=SIGMAZH(IDPML(I,J,K))*((XK-ZN+XNPML+0.5)/XNPML)**2.
      ENDIF
      

      IF (HSIGMAZ.LE.0.) THEN
       DTMSZ=1.
       DTMSDZ=DT/(DELZ*XMU0)
      ELSE
       DTMSZ=EXP(-(HSIGMAZ*DT)/XMU0)
       DTMSDZ=(1.-DTMSZ)/(HSIGMAZ*DELZ)
      ENDIF

      IF (HSIGMAX.LE.0.) THEN
       DTMSX=1.
       DTMSDX=DT/(DELX*XMU0)
      ELSE
       DTMSX=EXP(-(HSIGMAX*DT)/XMU0)
       DTMSDX=(1.-DTMSX)/(HSIGMAX*DELX)
      ENDIF
C
C          PML INTERFACE
C
          IF (I.EQ.NXSM1.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZSM1) THEN


	   HY(I,J,K)=HY(I,J,K)-(EX(I,J,K+1)-EX(I,J,K))*DTMDZ
     $               +(EZX(I+1,J,K)+EZY(I+1,J,K)-EZ(I,J,K))*DTMDX

	  ELSEIF (I.GT.NXB.AND.I.LT.NXSM1.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZSM1) THEN

	   HY(I,J,K)=HY(I,J,K)-(EXY(I,J,K+1)+EXZ(I,J,K+1)
     $               -EX(I,J,K))*DTMDZ+(EZ(I+1,J,K)-EZ(I,J,K))*DTMDX
     
     	  ELSEIF (I.EQ.NXSM1.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZSM1) THEN

	   HY(I,J,K)=HY(I,J,K)-(EXY(I,J,K+1)+EXZ(I,J,K+1)
     $              -EX(I,J,K))*DTMDZ
     $              +(EZX(I+1,J,K)+EZY(I+1,J,K)-EZ(I,J,K))*DTMDX


	  ELSEIF (I.EQ.NXB.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
	   HYX(I,J,K)=HYX(I,J,K)*DTMSX+(EZ(I+1,J,K)
     $                           -EZX(I,J,K)-EZY(I,J,K))*DTMSDX
	   HYZ(I,J,K)=HYZ(I,J,K)*DTMSZ-(EXY(I,J,K+1)+EXZ(I,J,K+1)
     $                           -EXY(I,J,K)-EXZ(I,J,K))*DTMSDZ


	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.EQ.NZB) THEN
           HYZ(I,J,K)=HYZ(I,J,K)*DTMSZ-(EX(I,J,K+1)
     $                           -EXY(I,J,K)-EXZ(I,J,K))*DTMSDZ
	   HYX(I,J,K)=HYX(I,J,K)*DTMSX+(EZX(I+1,J,K)+EZY(I+1,J,K)
     $                           -EZX(I,J,K)-EZY(I,J,K))*DTMSDX

C
C         PML
C
	  ELSE

           HYX(I,J,K)=HYX(I,J,K)*DTMSX
     $              +(EZX(I+1,J,K)+EZY(I+1,J,K)
     $              -EZX(I,J,K)-EZY(I,J,K))*DTMSDX
           HYZ(I,J,K)=HYZ(I,J,K)*DTMSZ
     $              -(EXY(I,J,K+1)+EXZ(I,J,K+1)
     $              -EXY(I,J,K)-EXZ(I,J,K))*DTMSDZ

          ENDIF

      RETURN
      END

C     ********************************************************
      SUBROUTINE PMLHZ(I,J,K)
      INCLUDE 'FDSAR.PAR'

      XJ=1*J
      XI=1*I

      IF(I.LE.NXB) THEN
        HSIGMAX=SIGMAXH(IDPML(I,J,K))*((XNPML-XI+0.5)/XNPML)**2.
      ELSE
        HSIGMAX=SIGMAXH(IDPML(I,J,K))*((XI-XN+XNPML+0.5)/XNPML)**2.
      ENDIF
      IF(J.LE.NYB) THEN
        HSIGMAY=SIGMAYH(IDPML(I,J,K))*((XNPML-XJ+0.5)/XNPML)**2.
      ELSE
        HSIGMAY=SIGMAYH(IDPML(I,J,K))*((XJ-YN+XNPML+0.5)/XNPML)**2.
      ENDIF

      IF (HSIGMAY.LE.0.) THEN
       DTMSY=1.
       DTMSDY=DT/(DELY*XMU0)
      ELSE
       DTMSY=EXP(-(HSIGMAY*DT)/XMU0)
       DTMSDY=(1.-DTMSY)/(HSIGMAY*DELY)
      ENDIF

      IF (HSIGMAX.LE.0.) THEN
       DTMSX=1.
       DTMSDX=DT/(DELX*XMU0)
      ELSE
       DTMSX=EXP(-(HSIGMAX*DT)/XMU0)
       DTMSDX=(1.-DTMSX)/(HSIGMAX*DELX)
      ENDIF
C
C          PML INTERFACE
C
          IF (I.EQ.NXSM1.AND.J.GT.NYB.AND.J.LT.NYSM1
     $              .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	   HZ(I,J,K)=HZ(I,J,K)-(EYX(I+1,J,K)+EYZ(I+1,J,K)
     $               -EY(I,J,K))*DTMDX+(EX(I,J+1,K)-EX(I,J,K))*DTMDY

	  ELSEIF (I.GT.NXB.AND.I.LT.NXSM1.AND.J.EQ.NYSM1
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	   HZ(I,J,K)=HZ(I,J,K)-(EY(I+1,J,K)-EY(I,J,K))*DTMDX
     $               +(EXY(I,J+1,K)+EXZ(I,J+1,K)-EX(I,J,K))*DTMDY

	  ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.EQ.NYB
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
	   HZY(I,J,K)=HZY(I,J,K)*DTMSY+(EX(I,J+1,K)
     $                           -EXY(I,J,K)-EXZ(I,J,K))*DTMSDY
	   HZX(I,J,K)=HZX(I,J,K)*DTMSX-(EYX(I+1,J,K)+EYZ(I+1,J,K)
     $                           -EYX(I,J,K)-EYZ(I,J,K))*DTMSDX


	  ELSEIF (I.EQ.NXB.AND.J.GT.NYB.AND.J.LT.NYS
     $                               .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	   HZX(I,J,K)=HZX(I,J,K)*DTMSX-(EY(I+1,J,K)
     $                           -EYX(I,J,K)-EYZ(I,J,K))*DTMSDX
	   HZY(I,J,K)=HZY(I,J,K)*DTMSY+(EXY(I,J+1,K)+EXZ(I,J+1,K)
     $                           -EXY(I,J,K)-EXZ(I,J,K))*DTMSDY


	  ELSEIF (I.EQ.NXSM1.AND.J.EQ.NYSM1
     $                               .AND.K.GT.NZB.AND.K.LT.NZS) THEN

	   HZ(I,J,K)=HZ(I,J,K)-(EYX(I+1,J,K)+EYZ(I+1,J,K)
     $               -EY(I,J,K))*DTMDX
     $               +(EXY(I,J+1,K)+EXZ(I,J+1,K)-EX(I,J,K))*DTMDY

C
C         PML
C
	  ELSE

           HZX(I,J,K)=HZX(I,J,K)*DTMSX
     $           -(EYX(I+1,J,K)+EYZ(I+1,J,K)
     $           -EYX(I,J,K)-EYZ(I,J,K))*DTMSDX
           HZY(I,J,K)=HZY(I,J,K)*DTMSY
     $           +(EXY(I,J+1,K)+EXZ(I,J+1,K)
     $           -EXY(I,J,K)-EXZ(I,J,K))*DTMSDY
          ENDIF

      RETURN
      END

C     ********************************************************
      
      SUBROUTINE PEC
      INCLUDE 'FDSAR.PAR'
       
      DO K=1,NZ
       DO J=1,NY
	 
	 I=1
	 EYX(I,J,K)=0.0
	 EYZ(I,J,K)=0.0
	 EZX(I,J,K)=0.0
	 EZY(I,J,K)=0.0
c         EY(I,J,K)=0.0
c         EZ(I,J,K)=0.0
	   
	 I=NX
	 EYX(I,J,K)=0.0
	 EYZ(I,J,K)=0.0
	 EZX(I,J,K)=0.0
	 EZY(I,J,K)=0.0
C         EY(I,J,K)=0.0
C         EZ(I,J,K)=0.0
	 
       ENDDO
      ENDDO
       
      DO K=1,NZ
       DO I=1,NX
	 
         J=1
         EXY(I,J,K)=0.0
         EXZ(I,J,K)=0.0
         EZX(I,J,K)=0.0
         EZY(I,J,K)=0.0
         EX(I,J,K)=0.0
         EZ(I,J,K)=0.0
	   
	 J=NY
	 EXY(I,J,K)=0.0
	 EXZ(I,J,K)=0.0
	 EZX(I,J,K)=0.0
	 EZY(I,J,K)=0.0
C         EX(I,J,K)=0.0
C         EZ(I,J,K)=0.0
	 
       ENDDO
      ENDDO

      DO J=1,NY
       DO I=1,NX
	 
	 K=1
	 EXY(I,J,K)=0.0
	 EXZ(I,J,K)=0.0
	 EYX(I,J,K)=0.0
	 EYZ(I,J,K)=0.0
C         EX(I,J,K)=0.0
C         EY(I,J,K)=0.0
	   
	 K=NZ
	 EXY(I,J,K)=0.0
	 EXZ(I,J,K)=0.0
	 EYX(I,J,K)=0.0
	 EYZ(I,J,K)=0.0
C         EX(I,J,K)=0.0
C         EY(I,J,K)=0.0

       ENDDO
      ENDDO

      RETURN
      END
C*****************************************************************
      SUBROUTINE ABSORBED
      INCLUDE 'FDSAR.PAR'
      
      E1T=0.
      E2T=0.
      E3T=0.

      DO 10 I=1,NX
      DO 10 J=1,NY
      DO 10 K=1,NZ

      IF(IDONE(I,J,K).GT.1)THEN
         E1=EX(I,J,K)
         E1T=E1T+SIGMA(IDONE(I,J,K))*E1**2
      ENDIF
      IF(IDTWO(I,J,K).GT.1)THEN
         E2=EY(I,J,K)
         E2T=E2T+SIGMA(IDTWO(I,J,K))*E2**2
      ENDIF
      IF(IDTHRE(I,J,K).GT.1)THEN
         E3=EZ(I,J,K)
         E3T=E3T+SIGMA(IDTHRE(I,J,K))*E3**2
      ENDIF
10    CONTINUE
      PABS=(E1T+E2T+E3T)*DELX*DELY*DELZ

      RETURN
      END      

C*********************************************
      SUBROUTINE POYNTING
      INCLUDE 'FDSAR.PAR'

      PYT=.0
C***********************************************
C (1) x=Xmax YZEYNDE  (Ey*Hz ve Ez*Hy iin)  *
C***********************************************
      I=NXS2
      P1=.0
      DO J=NYS1,NYS2
	DO K=NZS1,NZS2
          E1=.5*(EY(I+1,J,K)+EY(I+1,J,K+1))
          E2=.5*(EZ(I+1,J,K)+EZ(I+1,J+1,K))
          H1=.25*(HY(I,J,K)+HY(I,J+1,K)
     *          +HY(I+1,J,K)+HY(I+1,J+1,K))
          H2=.25*(HZ(I,J,K)+HZ(I,J,K+1)
     *          +HZ(I+1,J,K)+HZ(I+1,J,K+1))
	  P1=P1+E1*H2-E2*H1
	END DO
      END DO

C***********************************************
C (2) X=Xmin YZEYNDE  (Ey*Hz ve Ez*Hy iin)  *
C***********************************************
      I=NXS1
      P2=.0
      DO J=NYS1,NYS2
	DO K=NZS1,NZS2
           E1=.5*(EY(I,J,K)+EY(I,J,K+1))
           E2=.5*(EZ(I,J,K)+EZ(I,J+1,K))
           H1=.25*(HY(I,J,K)+HY(I,J+1,K)
     *           +HY(I-1,J,K)+HY(I-1,J+1,K))
           H2=.25*(HZ(I,J,K)+HZ(I,J,K+1)
     *           +HZ(I-1,J,K)+HZ(I-1,J,K+1))
	   P2=P2+E1*H2-E2*H1
        ENDDO
      ENDDO

C***********************************************
C (3) y=Ymax YZEYNDE  (Ex*Hz ve Ez*Hx iin)  *
C***********************************************
      J=NYS2
      P3=.0
      DO I=NXS1,NXS2
	DO K=NZS1,NZS2
          E1=.5*(EX(I,J+1,K)+EX(I,J+1,K+1))
          E2=.5*(EZ(I,J+1,K)+EZ(I+1,J+1,K))
          H1=.25*(HX(I,J,K)+HX(I+1,J+1,K)
     *          +HX(I+1,J,K)+HX(I,J+1,K))
          H2=.25*(HZ(I,J,K)+HZ(I,J+1,K)
     *          +HZ(I,J+1,K+1)+HZ(I,J,K+1))
	  P3=P3+E2*H1-E1*H2
	ENDDO
      ENDDO

C***********************************************
C (4) y=Ymin YZEYNDE  (Ex*Hz ve Ez*Hx iin)  *
C***********************************************
      J=NYS1
      P4=.0
      DO I=NXS1,NXS2
	DO K=NZS1,NZS2
           E1=.5*(EX(I,J,K)+EX(I,J,K+1))
           E2=.5*(EZ(I,J,K)+EZ(I+1,J,K))
           H1=.25*(HX(I,J,K)+HX(I+1,J,K)
     *           +HX(I+1,J-1,K)+HX(I,J-1,K))
           H2=.25*(HZ(I,J,K)+HZ(I,J,K+1)
     *           +HZ(I,J-1,K)+HZ(I,J-1,K+1))
	   P4=P4+E2*H1-E1*H2
        ENDDO
      ENDDO

C***********************************************
C (5) z=Zmax YZEYNDE  (Ex*Hy ve Ey*Hx iin)  *
C***********************************************
      K=NZS2
      P5=.0
      DO I=NXS1,NXS2
	DO J=NYS1,NYS2
          E1=.5*(EX(I,J,K+1)+EX(I,J+1,K+1))
          E2=.5*(EY(I+1,J,K+1)+EY(I,J,K+1))
          H1=.25*(HX(I,J,K)+HX(I+1,J,K)
     *          +HX(I,J,K+1)+HX(I+1,J,K+1))
          H2=.25*(HY(I,J,K)+HY(I,J+1,K)
     *          +HY(I,J,K+1)+HY(I,J+1,K+1))
	  P5=P5+E1*H2-E2*H1
        ENDDO
      ENDDO

C***********************************************
C (6) z=Zmin YZEYNDE  (Ex*Hy ve Ey*Hx iin)  *
C***********************************************
      K=NZS1
      P6=.0
      DO I=NXS1,NXS2
	DO J=NYS1,NYS2
          E1=.5*(EX(I,J,K)+EX(I,J+1,K))
          E2=.5*(EY(I,J,K)+EY(I+1,J,K))
          H1=.25*(HX(I,J,K)+HX(I+1,J,K)
     *          +HX(I,J,K-1)+HX(I+1,J,K-1))
          H2=.25*(HY(I,J,K)+HY(I,J+1,K)
     *          +HY(I,J,K-1)+HY(I,J+1,K-1))
	  P6=P6+E1*H2-E2*H1
        ENDDO
      ENDDO
      PYT=(P1-P2+P3-P4+P5-P6)*delz**2

      RETURN
      END       

C******** WRITE ABSORBED AND POYNTING POWERS ******************
      SUBROUTINE POWER
      INCLUDE 'FDSAR.PAR'

       WRITE(65,*) T*1.E9,PABS*1.E3,PYT*1.E3  ! MILIWATT
78     FORMAT(2(F18.10,1X))

      RETURN
      END

C*********************************************
      SUBROUTINE SAR_PEAK
      INCLUDE 'FDSAR.PAR'
      REAL SMRK(2)

      DO MARG=1,2
        SMRK(MARG) = 0.
        INBR=0
        DO ISS=MSRXB(MARG),MSRXE(MARG)
         DO JSS=MSRYB(MARG),MSRYE(MARG)
          DO KSS=MSRZB(MARG),MSRZE(MARG)
          INBR=INBR+1
          SE1=EX(ISS,JSS,KSS)**2
     >        *SIGMA(IDONE(ISS,JSS,KSS))/
     >         DENSTY(IDONE(ISS,JSS,KSS))
          SE2=EY(ISS,JSS,KSS)**2
     >        *SIGMA(IDTWO(ISS,JSS,KSS))/
     >         DENSTY(IDTWO(ISS,JSS,KSS))
          SE3=EZ(ISS,JSS,KSS)**2
     >        *SIGMA(IDTHRE(ISS,JSS,KSS))/
     >         DENSTY(IDTHRE(ISS,JSS,KSS))
          SMRK(MARG)=SMRK(MARG)+SE1+SE2+SE3
          ENDDO
         ENDDO
        ENDDO
        SMRK(MARG)=SMRK(MARG)/INBR
      ENDDO

      WRITE(60,*) T*1.E9,(SMRK(I),I=1,2)

      RETURN
      END
C***** CALCULATE SAR ALONG VERTICAL AND HORIZONTAL LINES ***
      SUBROUTINE SAR_LINE
      INCLUDE 'FDSAR.PAR'

C ****** SAR CALCULATION ALONG X *********
        DO ISS=20+NPML,29+NPML
          SE1=EX(ISS,JB,KB)**2
     >        *SIGMA(IDONE(ISS,JB,KB))/
     >         DENSTY(IDONE(ISS,JB,KB))
          SE2=EY(ISS,JB,KB)**2
     >        *SIGMA(IDTWO(ISS,JB,KB))/
     >         DENSTY(IDTWO(ISS,JB,KB))
          SE3=EZ(ISS,JB,KB)**2
     >        *SIGMA(IDTHRE(ISS,JB,KB))/
     >         DENSTY(IDTHRE(ISS,JB,KB))
          SAR=SE1+SE2+SE3
          WRITE(80,*) ISS,SAR
        ENDDO

C ****** SAR CALCULATION ALONG Z *********
        ISS=25+NPML
        DO KSS=15+NPML,26+NPML
          SE1=EX(ISS,JB,KSS)**2
     >        *SIGMA(IDONE(ISS,JB,KSS))/
     >         DENSTY(IDONE(ISS,JB,KSS))
          SE2=EY(ISS,JB,KSS)**2
     >        *SIGMA(IDTWO(ISS,JB,KSS))/
     >         DENSTY(IDTWO(ISS,JB,KSS))
          SE3=EZ(ISS,JB,KSS)**2
     >        *SIGMA(IDTHRE(ISS,JB,KSS))/
     >         DENSTY(IDTHRE(ISS,JB,KSS))
          SAR=SE1+SE2+SE3
          WRITE(90,*) KSS,SAR
        ENDDO

      RETURN
      END      
C********** END ** END  ** END ****************
