C*******************************************************
C    PROGRAM    : SEDFT.FOR                            *
C    DATE       : MARCH 2002                           *
C    AUTHOR     : M. ORHAN OZYALCIN                    *
C    PURPOSE    : DFT ANALYSIS OF FDSE TIME DATA       *
C*******************************************************
        COMPLEX J,CEZ0(4),CEZ(4), CS
        REAL EZ0(10000,4),EZ(10000,4),TM(10000), SOUR(10000)
        INTEGER NSTOP(2)

        PARAMETER(DEL=1.E-2,FMIN=0.001,FMAX=1.,DF=0.02,C=3.E8)

        PI=4.*ATAN(1.)
        NSTOP(1)=600

       OPEN(15,FILE='SE.INP')

       READ (15,*) NN,NN,NN,NN
       READ (15,*) NOBS

       DO I=1,NOBS
          READ (15,*) DM,DM,DM
       ENDDO

       READ (15,*) NSTOP(2)

       READ (15,*) NHAN

       CLOSE (15)

        OPEN(UNIT=44,FILE='SOURCE-F.DAT')

        OPEN(UNIT=20,FILE='F-SE.DAT')
        OPEN(UNIT=21,FILE='F-FREE.DAT')   ! NO EUT
        OPEN(UNIT=23,FILE='F-EUT.DAT')   ! EUT

        DO I=1,NSTOP(2)
          DO K=1,NOBS
           EZ0(I,K)=0.
           EZ(I,K)=0.
          END DO
        END DO

        DO IM=1,NSTOP(1)
	       READ(21,*) DM,(EZ0(IM,K),K=1,NOBS)
	  END DO

        DO IM=1,NSTOP(2)
             READ(23,*) TM(IM),(EZ(IM,K),K=1,NOBS)
	  END DO

        DO IM=1,NSTOP(1)
	     READ(44,*) DM,SOUR(IM)
	  END DO


C      TIME in NANOSEC  and FREQ in GHz

       J=CMPLX(0.0,1.0)

       DO F=FMIN,FMAX,DF
         DO K=1,NOBS
           CEZ0(K)=CMPLX(0.0,0.0)
           CEZ(K)=CMPLX(0.0,0.0)
	     
           DO IM=1,NSTOP(2)
C*********** HANNING WINDOW ******************************
      IF(NHAN.EQ.1) THEN
         EZ0(IM,K)=EZ0(IM,K)*0.5*(1+COS(PI*REAL(IM)/REAL(ITRATE)))
         EZ(IM,K)=EZ(IM,K)*0.5*(1+COS(PI*REAL(IM)/REAL(ITRATE)))
      ENDIF
C*********************************************************
            CEZ0(K)=CEZ0(K)+EZ0(IM,K)*CEXP(-J*2.*PI*F*TM(IM))
            CEZ(K)=CEZ(K)+EZ(IM,K)*CEXP(-J*2.*PI*F*TM(IM))
	     END DO
         END DO
         WRITE(20,111) F, (20.*LOG10(CABS(CEZ0(KK)/CEZ(KK))),KK=1,NOBS)

111      FORMAT(F10.6,1X,4(F12.6,1X))
      END DO
      
C******* SOURCE DFT ********	
	DO F=FMIN,FMAX,DF
         CS=CMPLX(0.0,0.0)
	   DO IM=1,NSTOP(2)
            CS=CS+SOUR(IM)*CEXP(-J*2.*PI*F*TM(IM))
         END DO
	   WRITE(44,*) F, 20.*LOG10(CABS(CS))
	END DO
      CLOSE(20)
      CLOSE(21)
      CLOSE(23)
	CLOSE(44)

      STOP
      END
