C*********************************************************************
C    PROGRAM        : TLMSNRCS.FOR                                   *
C    AUTHOR         : M. ORHAN OZYALCIN                              *
C    DATE           : MAY 1999                                       *
C    MODIFIED       : FEB 2001                                       *
C    PURPOSE        : TO SIMULATE TIME DATA OF FAR FIELD BEHAVIOR    *
C                     OF A CHOSEN TARGET ALONG A GIVEN DIRECTION     *
C    COMPARISON     : F-SNRCS.FOR                                    *
C*********************************************************************

      PROGRAM SNRCSPML
      INCLUDE 'T-SNRCS.PAR'

      OPEN(UNIT=15,FILE='SNRCS.INP')
      OPEN(UNIT=30,FILE='T-SNFAR.DAT')
      OPEN(UNIT=55,FILE='T-SNNEAR.DAT')
      OPEN(UNIT=40,FILE='T-SOURCE.DAT')

      READ(15,*) NTYPE          !1-5 SCENARIO 
      READ(15,*) O_LENGTH       !LONGEST DIMENSION 
      READ(15,*) NXO1,NYO1,NZO1 ! OBSERVATION POINT-1
      READ(15,*) THINC,PHINC    !ANGLES OF INCIDENT FIELD
      READ(15,*) NPOLAR         ! 1 TETA, 0 PHI (POLARIZATION)
      READ(15,*) TETA,PHI       !FAR FIELD ANGLES

      CLOSE(15)

      NXO1=NXO1+NPML
      NYO1=NYO1+NPML
      NZO1=NZO1+NPML



      IF (NPOLAR.EQ.1) THEN
       ETHINC=1.
       EPHINC=0.          
      ELSE
       ETHINC=0.
       EPHINC=1.
      ENDIF          

      IF (NTYPE.EQ.1.OR.NTYPE.EQ.5) THEN
          DEL=O_LENGTH/80.
      ELSE
          DEL=O_LENGTH/40.
      ENDIF


      CALL SNRCS

      REFTH=0.06
      GM=1.9
	ESIGMAM=-LOG(REFTH)*EPS0*CISIK*(GM-1.)/(2.*DEL*(GM**XNPML-1.)) 	
	HSIGMAM=ESIGMAM*XMU0/EPS0

C************************************
      CALL ZERO  
      CALL PMLCUBE
      CALL PMLSETUP
      CALL BUILD(NTYPE)  ! STRUCTURE IS SPESIFIED
      CALL PARAMET       ! CONSTANTS AND PARAMETERS ARE SPECIFIED

C*********************************
C  TIME ITERATION STARTS         *
C*********************************
      DO 60 ITIME = 1,ITRATE

        TT=REAL(ITIME)*DT
        CALL EXCITE
        DO  K = 1,NZE
           DO  J = 1,NYE
             DO  I = 1,NXE
                  
             V1 = V(K,J,I,1)
             V2 = V(K,J,I,2)
             V3 = V(K,J,I,3)
             V4 = V(K,J,I,4)
             V5 = V(K,J,I,5)
             V6 = V(K,J,I,6)
             V7 = V(K,J,I,7)
             V8 = V(K,J,I,8)
             V9 = V(K,J,I,9)
             V10 = V(K,J,I,10)
             V11 = V(K,J,I,11)
             V12 = V(K,J,I,12)

C*** Vr = S * Vi 
      IF(IDPML(K,J,I).EQ.27) THEN
          IF(IDCELL(K,J,I).EQ.1) THEN
            CALL SCAT_PEC(K,J,I)
          ELSE
            CALL SCAT(K,J,I)
          ENDIF
      ELSE
          CALL SCAT_PGM(K,J,I)
      ENDIF

          END DO
        END DO
      END DO

C
      CALL CONNECTION
      CALL OUTPUT(NZO1,NYO1,NXO1,55)
      WRITE(*,*) ITIME,EXSG,EYSG,EZSG  ! EKRANA YAZDIR

C*****************************************
C NEAR FIELD - FAR FIELD EXTRAPOLATION   *
C*****************************************
      CALL YAKUZ

      GGIR(ITIME)=SQRT(EXI(KC,JC,IC)**2+EYI(KC,JC,IC)**2
     $   +EZI(KC,JC,IC)**2)
      IF(GGMAX.LT.GGIR(ITIME)) GGMAX=GGIR(ITIME)
      WRITE(40,*) TT*1.E9,EXI(KC,JC,IC),EYI(KC,JC,IC)
     $           ,EZI(KC,JC,IC)

C******************************
C   END OF TIME LOOP          *
C******************************
 60        CONTINUE

C******************************************
C    OFF-LINE FAR FIELD EXTRAPOLATION     *
C******************************************
      TMAX=0.
      PMAX=0.
      DO 500 N=-MM,ITRATE+MM
      WTETA=WX(N)*CPHI*CTETA+WY(N)*SPHI*CTETA
     *      -WZ(N)*STETA
      WPHI=-WX(N)*SPHI+WY(N)*CPHI

      UTETA=UX(N)*CPHI*CTETA+UY(N)*SPHI*CTETA
     *      -UZ(N)*STETA
      UPHI=-UX(N)*SPHI+UY(N)*CPHI

      SABIT=12.E8*PI*DT

      FETETA(N)=(-ZO*WTETA-UPHI)/SABIT
      FEPHI(N) =(-ZO*WPHI+UTETA)/SABIT
      IF(ABS(FETETA(N)).GT.TMAX) TMAX=ABS(FETETA(N))
      IF(ABS(FEPHI(N)).GT.PMAX) PMAX=ABS(FEPHI(N))

 500  CONTINUE

      DO 501 N=-MM,ITRATE+MM
         WRITE(30,77) N*DT*1.E9,FETETA(N),FEPHI(N)
  77   FORMAT(F9.5,1X,2(F16.10,1X))
  501 CONTINUE

C**************************

175   FORMAT(4(F15.8,1X))

      CLOSE(30)
      CLOSE(40)
      CLOSE(55)

      STOP
      END

C**************************************************

      SUBROUTINE ZERO
      INCLUDE 'T-SNRCS.PAR'

       DO 11 K = 1,NZE
       DO 11 J = 1,NYE
       DO 11 I = 1,NXE
       DO 11 L = 1,NT2      
           V(K,J,I,L)=0.0
11     CONTINUE

        DO L = 0,9
          ER(L) = 1.0
          SIGMA(L) = 0.0
          YNR(L) = 4.E-7     ! AIR EVERYWHERE
          GNR(L) = 0.  
          RV(L) = 0.5/HDB !0.5 
          RI(L) = 0.5/HDB !0.5
        END DO

        V25 = 0.
        V26 = 0.
        V27 = 0.

C****************************
       DO 15 K = 1,NZE
       DO 15 J = 1,NYE
       DO 15 I = 1,NXE
          IDCELL(K,J,I) = 0     ! AIR EVERYWHERE
          IDPML(K,J,I) = 27
15     CONTINUE

        DO I=1,27
          SIGMAXE(I)=0.0     
          SIGMAYE(I)=0.0
          SIGMAZE(I)=0.0
          SIGMAXH(I)=0.0
          SIGMAYH(I)=0.0
          SIGMAZH(I)=0.0
        ENDDO       
 
      GGMAX=-1000.0

      RETURN
      END

C*************************************************

        SUBROUTINE PARAMET
        INCLUDE 'T-SNRCS.PAR'

       ALPHA = 2.74E18*BAND*BAND     ! BAND in GHz
       SHIFT= 4.0/SQRT(ALPHA)

        NXIB(1)=16+NPML
        NXIE(1)=55+NPML
        NYIB(1)=16+NPML
        NYIE(1)=95+NPML
        NZIB(1)=26+NPML
        NZIE(1)=45+NPML

        NXIB(2)=16+NPML
        NXIE(2)=55+NPML
        NYIB(2)=36+NPML
        NYIE(2)=55+NPML
        NZIB(2)=16+NPML
        NZIE(2)=55+NPML


        NXIB(3)=35+NPML
        NXIE(3)=35+NPML
        NYIB(3)=24+NPML
        NYIE(3)=87+NPML
        NZIB(3)=16+NPML
        NZIE(3)=55+NPML


        NXIB(4)=25+NPML
        NXIE(4)=55+NPML
        NYIB(4)=24+NPML
        NYIE(4)=87+NPML
        NZIB(4)=16+NPML
        NZIE(4)=55+NPML


         DO M=1,4
          NEX1(1,M) = NXIB(M)
          NEY1(1,M) = NYIB(M)
          NEZ1(1,M) = NZIB(M)
          NEX2(1,M) = NXIB(M)
          NEY2(1,M) = NYIE(M)
          NEZ2(1,M) = NZIE(M)

          NEX1(2,M) = NXIB(M)
          NEY1(2,M) = NYIB(M)
          NEZ1(2,M) = NZIB(M)
          NEX2(2,M) = NXIE(M)
          NEY2(2,M) = NYIB(M)
          NEZ2(2,M) = NZIE(M)

          NEX1(3,M) = NXIB(M)
          NEY1(3,M) = NYIB(M)
          NEZ1(3,M) = NZIB(M)
          NEX2(3,M) = NXIE(M)
          NEY2(3,M) = NYIE(M)
          NEZ2(3,M) = NZIB(M)

          NEX1(4,M) = NXIE(M)
          NEY1(4,M) = NYIB(M)
          NEZ1(4,M) = NZIB(M)
          NEX2(4,M) = NXIE(M)
          NEY2(4,M) = NYIE(M)
          NEZ2(4,M) = NZIE(M)

          NEX1(5,M) = NXIB(M)
          NEY1(5,M) = NYIE(M)
          NEZ1(5,M) = NZIB(M)
          NEX2(5,M) = NXIE(M)
          NEY2(5,M) = NYIE(M)
          NEZ2(5,M) = NZIE(M)

          NEX1(6,M) = NXIB(M)
          NEY1(6,M) = NYIB(M)
          NEZ1(6,M) = NZIE(M)
          NEX2(6,M) = NXIE(M)
          NEY2(6,M) = NYIE(M)
          NEZ2(6,M) = NZIE(M)

         ENDDO


        DO L=1,3
          NEID(L) = L
          NEID(4) = 1
          NEID(5) = 2
          NEID(6) = 3
        ENDDO
 
C********** HUYGENS YUZEYI OLUSTURULACAK *************
          NOX1(1) = NXS1
          NOY1(1) = NYS1
          NOZ1(1) = NZS1
          NOX2(1) = NXS1
          NOY2(1) = NYS2
          NOZ2(1) = NZS2

          NOX1(2) = NXS1
          NOY1(2) = NYS1
          NOZ1(2) = NZS1
          NOX2(2) = NXS2
          NOY2(2) = NYS1
          NOZ2(2) = NZS2

          NOX1(3) = NXS1
          NOY1(3) = NYS1
          NOZ1(3) = NZS1
          NOX2(3) = NXS2
          NOY2(3) = NYS2
          NOZ2(3) = NZS1

          NOX1(4) = NXS2
          NOY1(4) = NYS1
          NOZ1(4) = NZS1
          NOX2(4) = NXS2
          NOY2(4) = NYS2
          NOZ2(4) = NZS2

          NOX1(5) = NXS1
          NOY1(5) = NYS2
          NOZ1(5) = NZS1
          NOX2(5) = NXS2
          NOY2(5) = NYS2
          NOZ2(5) = NZS2

          NOX1(6) = NXS1
          NOY1(6) = NYS1
          NOZ1(6) = NZS2
          NOX2(6) = NXS2
          NOY2(6) = NYS2
          NOZ2(6) = NZS2


      RETURN
      END

C******************************************************
C  BUILD THE STRUCTURE                                *
C  IDCELL(K,J,I)=0 AIR; IDCELL(K,J,I)=1 PEC;          * 
C  IDCELL(K,J,I)=2,...,9 OTHER MATERIALS              *
C******************************************************

      SUBROUTINE BUILD(NTY)
      INCLUDE 'T-SNRCS.PAR'


      IF(NTY.EQ.1) THEN
         CALL DCUBE(26+NPML,16+NPML,16+NPML,45+NPML,95+NPML,55+NPML,1)

C******** DIHEDRAL *******************
      ELSEIF(NTY.EQ.2) THEN

         CALL DCUBE(16+NPML,36+NPML,16+NPML,55+NPML,36+NPML,55+NPML,1)
         CALL DCUBE(16+NPML,37+NPML,16+NPML,16+NPML,55+NPML,55+NPML,1)

C******** 4-ELEMENT ARRAY ************      
      ELSEIF(NTY.EQ.3) THEN
         CALL DCUBE(16+NPML,25+NPML,35+NPML,55+NPML,25+NPML,35+NPML,1)   
         CALL DCUBE(16+NPML,45+NPML,35+NPML,55+NPML,45+NPML,35+NPML,1)
         CALL DCUBE(16+NPML,65+NPML,35+NPML,55+NPML,65+NPML,35+NPML,1)
         CALL DCUBE(16+NPML,85+NPML,35+NPML,55+NPML,85+NPML,35+NPML,1)

C******** 2 * 4-ELEMENT ARRAY ************     
      ELSEIF(NTY.EQ.4) THEN
         CALL DCUBE(16+NPML,25+NPML,25+NPML,55+NPML,25+NPML,25+NPML,1)   
         CALL DCUBE(16+NPML,45+NPML,25+NPML,55+NPML,45+NPML,25+NPML,1)
         CALL DCUBE(16+NPML,65+NPML,25+NPML,55+NPML,65+NPML,25+NPML,1)
         CALL DCUBE(16+NPML,85+NPML,25+NPML,55+NPML,85+NPML,25+NPML,1)

         CALL DCUBE(16+NPML,25+NPML,45+NPML,55+NPML,25+NPML,45+NPML,1)   
         CALL DCUBE(16+NPML,45+NPML,45+NPML,55+NPML,45+NPML,45+NPML,1)
         CALL DCUBE(16+NPML,65+NPML,45+NPML,55+NPML,65+NPML,45+NPML,1)
         CALL DCUBE(16+NPML,85+NPML,45+NPML,55+NPML,85+NPML,45+NPML,1)


C******** PLANE MODEL ************      
      ELSEIF(NTY.EQ.5) THEN
         CALL DCUBE(25+NPML,15+NPML,35+NPML,34+NPML,84+NPML,35+NPML,1)    
         CALL DCUBE(30+NPML,55+NPML,15+NPML,30+NPML,64+NPML,54+NPML,1) 
         CALL DCUBE(30+NPML,20+NPML,25+NPML,30+NPML,25+NPML,44+NPML,1) 
         DO I=1,5 
          CALL DCUBE(25+NPML,85+2*(I-1)+NPML,35+NPML,34-I+NPML,
     >               86+2*(I-1)+NPML,35+NPML,1)
         ENDDO

         DO I=1,5 
          CALL DCUBE(35+2*(I-1)+NPML,15+NPML,35+NPML,
     >               36+2*(I-1)+NPML,20-I+NPML,35+NPML,1)
         ENDDO

      END IF

      RETURN
      END

C*************************************************************

      SUBROUTINE DCUBE(KSTRT,JSTRT,ISTRT,KEND,JEND,IEND,MTYPE)
      INCLUDE 'T-SNRCS.PAR'

        DO K = KSTRT,KEND
          DO J = JSTRT,JEND
            DO I = ISTRT,IEND
               IDCELL(K,J,I) = MTYPE !
            ENDDO
          ENDDO
        ENDDO

        RETURN
        END

C*************************************************************
C  SCATTERED VOLTAGES IN THE DIELECTRIC ----  Vr = S * Vi    *
C*************************************************************

      SUBROUTINE SCAT(KS,JS,IS)
      INCLUDE 'T-SNRCS.PAR'

             V13 = V(KS,JS,IS,13)
             V14 = V(KS,JS,IS,14)
             V15 = V(KS,JS,IS,15)

      VX=RV(IDCELL(KS,JS,IS))*(V1+V2+V9+V12+YNR(IDCELL(KS,JS,IS))*V13)
      VY=RV(IDCELL(KS,JS,IS))*(V3+V4+V8+V11+YNR(IDCELL(KS,JS,IS))*V14)
      VZ=RV(IDCELL(KS,JS,IS))*(V5+V6+V7+V10+YNR(IDCELL(KS,JS,IS))*V15)
      RIX=RI(IDCELL(KS,JS,IS))*(V5-V7+V8-V4)
      RIY=RI(IDCELL(KS,JS,IS))*(V2-V9+V10-V6)
      RIZ=RI(IDCELL(KS,JS,IS))*(V3-V11+V12-V1)
 
       V(KS,JS,IS,1) = VX + RIZ - V12
       V(KS,JS,IS,2) = VX - RIY - V9 
       V(KS,JS,IS,3) = VY - RIZ - V11
       V(KS,JS,IS,4) = VY + RIX - V8 
       V(KS,JS,IS,5) = VZ - RIX - V7 
       V(KS,JS,IS,6) = VZ + RIY - V10
       V(KS,JS,IS,7) = VZ + RIX - V5 
       V(KS,JS,IS,8) = VY - RIX - V4 
       V(KS,JS,IS,9) = VX + RIY - V2 
       V(KS,JS,IS,10)= VZ - RIY - V6 
       V(KS,JS,IS,11)= VY + RIZ - V3 
       V(KS,JS,IS,12)= VX - RIZ - V1 

       V(KS,JS,IS,13)= VX - V13
       V(KS,JS,IS,14)= VY - V14
       V(KS,JS,IS,15)= VZ - V15

       V25 = VX 
       V26 = VY 
       V27 = VZ 

        RETURN
        END

C*************************************************************
C  SCATTERED VOLTAGES IN PML REGION     ----  Vr = S * Vi    *
C*************************************************************

      SUBROUTINE SCAT_PGM(KS,JS,IS)
      INCLUDE 'T-SNRCS.PAR'

             V13 = V(KS,JS,IS,13)
             V14 = V(KS,JS,IS,14)
             V15 = V(KS,JS,IS,15)
             V16 = V(KS,JS,IS,16)
             V17 = V(KS,JS,IS,17)
             V18 = V(KS,JS,IS,18)

             V19 = V(KS,JS,IS,19) ! KISA DEVRE YAN-HAT
             V20 = V(KS,JS,IS,20) ! KISA DEVRE YAN-HAT
             V21 = V(KS,JS,IS,21) ! KISA DEVRE YAN-HAT
             V22 = V(KS,JS,IS,22) ! KISA DEVRE YAN-HAT
             V23 = V(KS,JS,IS,23) ! KISA DEVRE YAN-HAT
             V24 = V(KS,JS,IS,24) ! KISA DEVRE YAN-HAT

      XI=1.*IS
      XJ=1.*JS
      XK=1.*KS                 

      IF(IS.LE.NXB) THEN
      L=1.*NXB-XI
      ESIGMAX=SIGMAXE(IDPML(KS,JS,IS))*EPMLR*GM**(L)
      ELSE
      L=XI-1.*NXS
      ESIGMAX=SIGMAXE(IDPML(KS,JS,IS))*EPMLR*GM**(L)
      ENDIF

      IF(JS.LE.NYB) THEN
      L=1.*NYB-XJ
      ESIGMAY=SIGMAYE(IDPML(KS,JS,IS))*EPMLR*GM**(L)
      ELSE
      L=XJ-1.*NYS
      ESIGMAY=SIGMAYE(IDPML(KS,JS,IS))*EPMLR*GM**(L)
      ENDIF
      
      IF(KS.LE.NZB) THEN
      L=1.*NZB-XK
      ESIGMAZ=SIGMAZE(IDPML(KS,JS,IS))*EPMLR*GM**(L)
      ELSE
      L=XK-1.*NZS
      ESIGMAZ=SIGMAZE(IDPML(KS,JS,IS))*EPMLR*GM**(L)
      ENDIF

      IF(IS.LE.NXB) THEN
        L=1.*NXB-XI
        HSIGMAX=SIGMAXH(IDPML(KS,JS,IS))*GM**(L)
      ELSE
        L=XI-1.*NXS
        HSIGMAX=SIGMAXH(IDPML(KS,JS,IS))*GM**(L)
      ENDIF

      IF(JS.LE.NYB) THEN
        L=1.*NYB-XJ
        HSIGMAY=SIGMAYH(IDPML(KS,JS,IS))*GM**(L)
      ELSE
        L=XJ-1.*NYS
        HSIGMAY=SIGMAYH(IDPML(KS,JS,IS))*GM**(L)
      ENDIF

      IF(KS.LE.NZB) THEN
        L=1.*NZB-XK
        HSIGMAZ=SIGMAZH(IDPML(KS,JS,IS))*GM**(L)
      ELSE
        L=XK-1.*NZS
        HSIGMAZ=SIGMAZH(IDPML(KS,JS,IS))*GM**(L)
      ENDIF

C*******************************************
        GXY = ESIGMAY*DEL*ZO
        GXZ = ESIGMAZ*DEL*ZO
        GYX = ESIGMAX*DEL*ZO
        GYZ = ESIGMAZ*DEL*ZO
        GZX = ESIGMAX*DEL*ZO
        GZY = ESIGMAY*DEL*ZO

        RXY = HSIGMAY*DEL/ZO
        RXZ = HSIGMAZ*DEL/ZO
        RYX = HSIGMAX*DEL/ZO
        RYZ = HSIGMAZ*DEL/ZO
        RZX = HSIGMAX*DEL/ZO
        RZY = HSIGMAY*DEL/ZO

        YX = 2.*EPMLR*DEL/(CISIK*DT)-4.
        YY = 2.*EPMLR*DEL/(CISIK*DT)-4.
        YZ = 2.*EPMLR*DEL/(CISIK*DT)-4.

        ZX = 2.*MUPMLR*DEL/(CISIK*DT)-4.
        ZY = 2.*MUPMLR*DEL/(CISIK*DT)-4.
        ZZ = 2.*MUPMLR*DEL/(CISIK*DT)-4.

        RVXY = 2./(4.+YX+GXY)
        RVXZ = 2./(4.+YX+GXZ)
        RVYX = 2./(4.+YY+GYX)
        RVYZ = 2./(4.+YY+GYZ)
        RVZX = 2./(4.+YZ+GZX)
        RVZY = 2./(4.+YZ+GZY)

        RIXY = 2./(4.+ZX+RXY)
        RIXZ = 2./(4.+ZX+RXZ)
        RIYX = 2./(4.+ZY+RYX)
        RIYZ = 2./(4.+ZY+RYZ)
        RIZX = 2./(4.+ZZ+RZX)
        RIZY = 2./(4.+ZZ+RZY)

      VXY=RVXY*(V1+V12+(YX+2.)*V13-2.*V14)
      VXZ=RVXZ*(V2+V9+(YX+2.)*V14-2.*V13)
      VYX=RVYX*(V3+V11+(YY+2.)*V15-2.*V16)
      VYZ=RVYZ*(V4+V8+(YY+2.)*V16-2.*V15)
      VZX=RVZX*(V6+V10+(YZ+2.)*V17-2.*V18)
      VZY=RVZY*(V5+V7+(YZ+2.)*V18-2.*V17)
      AXY=RIXY*(V5-V7+(1.+2./ZX)*V19-(2./ZX)*V20)
      AXZ=RIXZ*(V8-V4+(1.+2./ZX)*V20-(2./ZX)*V19)
      AYX=RIYX*(V10-V6+(1.+2./ZY)*V21-(2./ZY)*V22)
      AYZ=RIYZ*(V2-V9+(1.+2./ZY)*V22-(2./ZY)*V21)
      AZX=RIZX*(V3-V11+(1.+2./ZZ)*V23-(2./ZZ)*V24)
      AZY=RIZY*(V12-V1+(1.+2./ZZ)*V24-(2./ZZ)*V23) 

       V(KS,JS,IS,1) = VXY + VXZ + AZX + AZY - V12
       V(KS,JS,IS,2) = VXY + VXZ - (AYX + AYZ) - V9 
       V(KS,JS,IS,3) = VYX + VYZ - (AZX + AZY) - V11
       V(KS,JS,IS,4) = VYX + VYZ + AXY + AXZ - V8 
       V(KS,JS,IS,5) = VZX + VZY - (AXY + AXZ) - V7 
       V(KS,JS,IS,6) = VZX + VZY + AYX + AYZ - V10
       V(KS,JS,IS,7) = VZX + VZY + AXY + AXZ - V5 
       V(KS,JS,IS,8) = VYX + VYZ - (AXY + AXZ) - V4 
       V(KS,JS,IS,9) = VXY + VXZ + AYX + AYZ - V2 
       V(KS,JS,IS,10)= VZX + VZY - (AYX + AYZ) - V6 
       V(KS,JS,IS,11)= VYX + VYZ + AZX + AZY - V3 
       V(KS,JS,IS,12)= VXY + VXZ - (AZX + AZY) - V1 

       V(KS,JS,IS,13)= VXY - V13
       V(KS,JS,IS,14)= VXZ - V14
       V(KS,JS,IS,15)= VYX - V15
       V(KS,JS,IS,16)= VYZ - V16
       V(KS,JS,IS,17)= VZX - V17
       V(KS,JS,IS,18)= VZY - V18

       V(KS,JS,IS,19)= -V19 +ZX*AXY
       V(KS,JS,IS,20)= -V20 +ZX*AXZ
       V(KS,JS,IS,21)= -V21 +ZY*AYX
       V(KS,JS,IS,22)= -V22 +ZY*AYZ
       V(KS,JS,IS,23)= -V23 +ZZ*AZX
       V(KS,JS,IS,24)= -V24 +ZZ*AZY

        RETURN
        END
C*************************************************************
C  SCATTERED VOLTAGES IN PEC       ----  Vr = -Vi            *
C*************************************************************

        SUBROUTINE SCAT_PEC(KS,JS,IS)
        INCLUDE 'T-SNRCS.PAR'
             V(KS,JS,IS,1) = -V1
             V(KS,JS,IS,2) = -V2
             V(KS,JS,IS,3) = -V3
             V(KS,JS,IS,4) = -V4
             V(KS,JS,IS,5) = -V5
             V(KS,JS,IS,6) = -V6
             V(KS,JS,IS,7) = -V7
             V(KS,JS,IS,8) = -V8
             V(KS,JS,IS,9) = -V9
             V(KS,JS,IS,10) = -V10
             V(KS,JS,IS,11) = -V11
             V(KS,JS,IS,12) = -V12
        RETURN
        END
C*******************************************************

      SUBROUTINE CONNECTION
      INCLUDE 'T-SNRCS.PAR'

       DO KS = 1,NZE
          K1=KS+1
       DO JS = 1,NYE
          J1=JS+1
       DO IS = 1,NXE
          I1=IS+1

       IF(IS.LT.NXE) THEN
         V0 = V(KS,JS,IS,10)
         V(KS,JS,IS,10) = V(KS,JS,I1,6)
         V(KS,JS,I1,6) = V0
         V0 = V(KS,JS,IS,11)
         V(KS,JS,IS,11) = V(KS,JS,I1,3)
         V(KS,JS,I1,3) = V0
       ENDIF

       IF(JS.LT.NYE) THEN
         V0 = V(KS,JS,IS,7)
         V(KS,JS,IS,7) = V(KS,J1,IS,5)
         V(KS,J1,IS,5) = V0
         V0 = V(KS,JS,IS,12)
         V(KS,JS,IS,12) = V(KS,J1,IS,1)
         V(KS,J1,IS,1) = V0
       ENDIF

       IF(KS.LT.NZE) THEN
         V0 = V(KS,JS,IS,8)
         V(KS,JS,IS,8) = V(K1,JS,IS,4)
         V(K1,JS,IS,4) = V0
         V0 = V(KS,JS,IS,9)
         V(KS,JS,IS,9) = V(K1,JS,IS,2)
         V(K1,JS,IS,2) = V0
       END IF

C*************************************

      CALL BOUN_ZERO(KS,JS,IS)  ! ZERO REFLECTION

          END DO
        END DO
      END DO

      RETURN
      END

C***************************************************

        SUBROUTINE EXCITE
        INCLUDE 'T-SNRCS.PAR'

       M=NTYPE

       DO L=1,6

       IF((NZIB(M).EQ.NZIE(M) .AND. L.EQ.6).OR.
     >    (NYIB(M).EQ.NYIE(M) .AND. L.EQ.5).OR.
     >    (NXIB(M).EQ.NXIE(M) .AND. L.EQ.4)) GOTO 1011

        DO K=NEZ1(L,M),NEZ2(L,M)
         DO J=NEY1(L,M),NEY2(L,M)
          DO I=NEX1(L,M),NEX2(L,M)

          IF(NEID(L).NE.1 .AND. IDCELL(K,J,I).EQ.1) THEN
C**************E_x ALANI***********
         V(K,J,I,1)=V(K,J,I,1)-EXI(K,J,I)
         V(K,J,I,2)=V(K,J,I,2)-EXI(K,J,I)
         V(K,J,I,9)=V(K,J,I,9)-EXI(K,J,I)
         V(K,J,I,12)=V(K,J,I,12)-EXI(K,J,I)
          ENDIF          

          IF(NEID(L).NE.2 .AND. IDCELL(K,J,I).EQ.1) THEN
C**************E_y ALANI***********
         V(K,J,I,3)=V(K,J,I,3)-EYI(K,J,I)
         V(K,J,I,4)=V(K,J,I,4)-EYI(K,J,I)
         V(K,J,I,8)=V(K,J,I,8)-EYI(K,J,I)
         V(K,J,I,11)=V(K,J,I,11)-EYI(K,J,I)
          ENDIF

          IF(NEID(L).NE.3 .AND. IDCELL(K,J,I).EQ.1) THEN
C**************E_z ALANI***********
         V(K,J,I,5)=V(K,J,I,5)-EZI(K,J,I)
         V(K,J,I,6)=V(K,J,I,6)-EZI(K,J,I)
         V(K,J,I,7)=V(K,J,I,7)-EZI(K,J,I)
         V(K,J,I,10)=V(K,J,I,10)-EZI(K,J,I)
          END IF

          END DO
         END DO
        END DO
1011    END DO

      RETURN
      END

C**********************************************

      SUBROUTINE OUTPUT(K,J,I,MDSY)
      INCLUDE 'T-SNRCS.PAR'

         EXSG =-RV(IDCELL(K,J,I))*(V(K,J,I,1)+V(K,J,I,2)+
     >   V(K,J,I,9)+V(K,J,I,12)+YNR(IDCELL(K,J,I))*V(K,J,I,13))

         EYSG =-RV(IDCELL(K,J,I))*(V(K,J,I,3)+V(K,J,I,4)+
     >   V(K,J,I,8)+V(K,J,I,11)+YNR(IDCELL(K,J,I))*V(K,J,I,14))

         EZSG =-RV(IDCELL(K,J,I))*(V(K,J,I,5)+V(K,J,I,6)+
     >   V(K,J,I,7)+V(K,J,I,10)+YNR(IDCELL(K,J,I))*V(K,J,I,15))

         WRITE(MDSY,*) TT*1.E9,EXSG,EYSG,EZSG

 175    FORMAT(4(F12.9,1X))

        RETURN
        END

C***************************************

      SUBROUTINE BOUN_PEC(KS,JS,IS)
      INCLUDE 'T-SNRCS.PAR'

        IF (IS.EQ.1) THEN
            V(KS,JS,IS,3) = -V(KS,JS,IS,3) !TAM YANSIMALI PEC
            V(KS,JS,IS,6) = -V(KS,JS,IS,6) !TAM YANSIMALI PEC
	END IF

        IF(IS.EQ.NXE) THEN
            V(KS,JS,IS,10) = -V(KS,JS,IS,10)  !TAM YANSIMALI PEC
            V(KS,JS,IS,11) = -V(KS,JS,IS,11)  !TAM YANSIMALI PEC
	END IF
	     
        IF (JS.EQ.1) THEN
             V(KS,JS,IS,1) = -V(KS,JS,IS,1)
             V(KS,JS,IS,5) = -V(KS,JS,IS,5)
	END IF

        IF(JS.EQ.NYE) THEN
            V(KS,JS,IS,7)  = -V(KS,JS,IS,7)        !TAM YANSIMALI PEC
            V(KS,JS,IS,12) = -V(KS,JS,IS,12)      !TAM YANSIMALI PEC
	END IF

        IF(KS.EQ.1) THEN
            V(KS,JS,IS,2) = -V(KS,JS,IS,2)  ! ARKA DIS Z-DUVAR 
            V(KS,JS,IS,4) = -V(KS,JS,IS,4)  ! PEC
	END IF

        IF (KS.EQ.NZE) THEN
            V(KS,JS,IS,8) = -V(KS,JS,IS,8)  ! ARKA IC Z-DUVAR
            V(KS,JS,IS,9) = -V(KS,JS,IS,9)  ! PEC
	END IF

        RETURN
        END

C***************************************

      SUBROUTINE BOUN_ZERO(KS,JS,IS)
      INCLUDE 'T-SNRCS.PAR'

	IF (IS.EQ.1) THEN
            V(KS,JS,IS,3) = 0. 
            V(KS,JS,IS,6) = 0.
	END IF

	IF(IS.EQ.NXE) THEN
            V(KS,JS,IS,10) = 0.
            V(KS,JS,IS,11) = 0.
	END IF
	     
	IF (JS.EQ.1) THEN
             V(KS,JS,IS,1) = 0.
             V(KS,JS,IS,5) = 0.
	END IF

	IF(JS.EQ.NYE) THEN
            V(KS,JS,IS,7)  = 0.
            V(KS,JS,IS,12) = 0.
	END IF

	IF(KS.EQ.1) THEN
            V(KS,JS,IS,2) = 0.
            V(KS,JS,IS,4) = 0.
	END IF

	IF (KS.EQ.NZE) THEN
            V(KS,JS,IS,8) = 0.
            V(KS,JS,IS,9) = 0.
	END IF

        RETURN
        END

C********************************************************
      SUBROUTINE PMLCUBE 
      INCLUDE 'T-SNRCS.PAR'
C
        DO K=1,NZE
        DO J=1,NYE
        DO I=1,NXE
C
C         PML KOSELERI
C
         IF (I.LE.NXB.AND.J.LE.NYB.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=1
         ELSEIF (I.GE.NXS.AND.J.LE.NYB.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=2
         ELSEIF (I.LE.NXB.AND.J.LE.NYB.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=3
         ELSEIF (I.GE.NXS.AND.J.LE.NYB.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=4
         ELSEIF (I.LE.NXB.AND.J.GE.NYS.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=5
         ELSEIF (I.GE.NXS.AND.J.GE.NYS.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=6
         ELSEIF (I.LE.NXB.AND.J.GE.NYS.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=7
         ELSEIF (I.GE.NXS.AND.J.GE.NYS.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=8
C
C         PML KENARLARI
C
         ELSEIF (I.LE.NXB.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=9
         ELSEIF (I.GE.NXS.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=10
         ELSEIF (I.LE.NXB.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=11
         ELSEIF (I.GE.NXS.AND.J.GT.NYB.AND.J.LT.NYS.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=12
C
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GE.NYS.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=13
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GE.NYS.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=14
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.LE.NYB.AND.K.LE.NZB) THEN
            IDPML(K,J,I)=15
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.LE.NYB.AND.K.GE.NZS) THEN
            IDPML(K,J,I)=16
C
         ELSEIF (I.LE.NXB.AND.J.GE.NYS.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(K,J,I)=17
         ELSEIF (I.GE.NXS.AND.J.GE.NYS.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(K,J,I)=18
         ELSEIF (I.LE.NXB.AND.J.LE.NYB.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(K,J,I)=19
         ELSEIF (I.GE.NXS.AND.J.LE.NYB.AND.K.GT.NZB.AND.K.LT.NZS) THEN
            IDPML(K,J,I)=20
C
C         PML YUZEYLERI (GENEL)
C
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.LE.NZB) THEN
          IDPML(K,J,I)=21
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                                          .AND.K.GE.NZS) THEN
          IDPML(K,J,I)=22
         ELSEIF (I.LE.NXB.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(K,J,I)=23
         ELSEIF (I.GE.NXS.AND.J.GT.NYB.AND.J.LT.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(K,J,I)=24
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.LE.NYB
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(K,J,I)=25
         ELSEIF (I.GT.NXB.AND.I.LT.NXS.AND.J.GE.NYS
     $                              .AND.K.GT.NZB.AND.K.LT.NZS) THEN
          IDPML(K,J,I)=26
         ELSE
           IDPML(K,J,I)=27
         ENDIF
        ENDDO
        ENDDO
        ENDDO

      RETURN
      END

C*******************************************************
      SUBROUTINE PMLSETUP
      INCLUDE 'T-SNRCS.PAR'
       
       SIGMAXE(1)=ESIGMAM
       SIGMAXE(2)=ESIGMAM
       SIGMAXE(3)=ESIGMAM
       SIGMAXE(4)=ESIGMAM
       SIGMAXE(5)=ESIGMAM
       SIGMAXE(6)=ESIGMAM
       SIGMAXE(7)=ESIGMAM
       SIGMAXE(8)=ESIGMAM
       SIGMAXE(9)=ESIGMAM
       SIGMAXE(10)=ESIGMAM
       SIGMAXE(11)=ESIGMAM
       SIGMAXE(12)=ESIGMAM
C
       SIGMAXE(13)=0.
       SIGMAXE(14)=0.
       SIGMAXE(15)=0.
       SIGMAXE(16)=0.
C
       SIGMAXE(17)=ESIGMAM
       SIGMAXE(18)=ESIGMAM
       SIGMAXE(19)=ESIGMAM
       SIGMAXE(20)=ESIGMAM
C
       SIGMAXE(21)=0.
       SIGMAXE(22)=0.
       SIGMAXE(23)=ESIGMAM
       SIGMAXE(24)=ESIGMAM
       SIGMAXE(25)=0.
       SIGMAXE(26)=0.
       SIGMAXE(27)=0.
       
C
       SIGMAYE(1)=ESIGMAM
       SIGMAYE(2)=ESIGMAM
       SIGMAYE(3)=ESIGMAM
       SIGMAYE(4)=ESIGMAM
       SIGMAYE(5)=ESIGMAM
       SIGMAYE(6)=ESIGMAM
       SIGMAYE(7)=ESIGMAM
       SIGMAYE(8)=ESIGMAM
C            
       SIGMAYE(9)=0.
       SIGMAYE(10)=0.
       SIGMAYE(11)=0.
       SIGMAYE(12)=0.
C
       SIGMAYE(13)=ESIGMAM
       SIGMAYE(14)=ESIGMAM
       SIGMAYE(15)=ESIGMAM
       SIGMAYE(16)=ESIGMAM
C
       SIGMAYE(17)=ESIGMAM
       SIGMAYE(18)=ESIGMAM
       SIGMAYE(19)=ESIGMAM
       SIGMAYE(20)=ESIGMAM
C
       SIGMAYE(21)=0.
       SIGMAYE(22)=0.
       SIGMAYE(23)=0.
       SIGMAYE(24)=0.
       SIGMAYE(25)=ESIGMAM
       SIGMAYE(26)=ESIGMAM
       SIGMAYE(27)=0.
       
C
       SIGMAZE(1)=ESIGMAM
       SIGMAZE(2)=ESIGMAM
       SIGMAZE(3)=ESIGMAM
       SIGMAZE(4)=ESIGMAM
       SIGMAZE(5)=ESIGMAM
       SIGMAZE(6)=ESIGMAM
       SIGMAZE(7)=ESIGMAM
       SIGMAZE(8)=ESIGMAM
C            
       SIGMAZE(9)=ESIGMAM
       SIGMAZE(10)=ESIGMAM
       SIGMAZE(11)=ESIGMAM
       SIGMAZE(12)=ESIGMAM
C
       SIGMAZE(13)=ESIGMAM
       SIGMAZE(14)=ESIGMAM
       SIGMAZE(15)=ESIGMAM
       SIGMAZE(16)=ESIGMAM
C
       SIGMAZE(17)=0.
       SIGMAZE(18)=0.
       SIGMAZE(19)=0.
       SIGMAZE(20)=0.
C
       SIGMAZE(21)=ESIGMAM
       SIGMAZE(22)=ESIGMAM
       SIGMAZE(23)=0.
       SIGMAZE(24)=0.
       SIGMAZE(25)=0.
       SIGMAZE(26)=0.
       SIGMAZE(27)=0.
C
       SIGMAXH(1)=HSIGMAM
       SIGMAXH(2)=HSIGMAM
       SIGMAXH(3)=HSIGMAM
       SIGMAXH(4)=HSIGMAM
       SIGMAXH(5)=HSIGMAM
       SIGMAXH(6)=HSIGMAM
       SIGMAXH(7)=HSIGMAM
       SIGMAXH(8)=HSIGMAM
C
       SIGMAXH(9)=HSIGMAM
       SIGMAXH(10)=HSIGMAM
       SIGMAXH(11)=HSIGMAM
       SIGMAXH(12)=HSIGMAM
C
       SIGMAXH(13)=0.
       SIGMAXH(14)=0.
       SIGMAXH(15)=0.
       SIGMAXH(16)=0.
C
       SIGMAXH(17)=HSIGMAM
       SIGMAXH(18)=HSIGMAM
       SIGMAXH(19)=HSIGMAM
       SIGMAXH(20)=HSIGMAM
C
       SIGMAXH(21)=0.
       SIGMAXH(22)=0.
       SIGMAXH(23)=HSIGMAM
       SIGMAXH(24)=HSIGMAM
       SIGMAXH(25)=0.
       SIGMAXH(26)=0.
       SIGMAXH(27)=0.
C
       SIGMAYH(1)=HSIGMAM
       SIGMAYH(2)=HSIGMAM
       SIGMAYH(3)=HSIGMAM
       SIGMAYH(4)=HSIGMAM
       SIGMAYH(5)=HSIGMAM
       SIGMAYH(6)=HSIGMAM
       SIGMAYH(7)=HSIGMAM
       SIGMAYH(8)=HSIGMAM
C            
       SIGMAYH(9)=0.
       SIGMAYH(10)=0.
       SIGMAYH(11)=0.
       SIGMAYH(12)=0.
C      
       SIGMAYH(13)=HSIGMAM
       SIGMAYH(14)=HSIGMAM
       SIGMAYH(15)=HSIGMAM
       SIGMAYH(16)=HSIGMAM
C
       SIGMAYH(17)=HSIGMAM
       SIGMAYH(18)=HSIGMAM
       SIGMAYH(19)=HSIGMAM
       SIGMAYH(20)=HSIGMAM
C      
       SIGMAYH(21)=0.
       SIGMAYH(22)=0.
       SIGMAYH(23)=0.
       SIGMAYH(24)=0.
       SIGMAYH(25)=HSIGMAM
       SIGMAYH(26)=HSIGMAM
       SIGMAYH(27)=0.
C
       SIGMAZH(1)=HSIGMAM
       SIGMAZH(2)=HSIGMAM
       SIGMAZH(3)=HSIGMAM
       SIGMAZH(4)=HSIGMAM
       SIGMAZH(5)=HSIGMAM
       SIGMAZH(6)=HSIGMAM
       SIGMAZH(7)=HSIGMAM
       SIGMAZH(8)=HSIGMAM
C            
       SIGMAZH(9)=HSIGMAM
       SIGMAZH(10)=HSIGMAM
       SIGMAZH(11)=HSIGMAM
       SIGMAZH(12)=HSIGMAM
C      
       SIGMAZH(13)=HSIGMAM
       SIGMAZH(14)=HSIGMAM
       SIGMAZH(15)=HSIGMAM
       SIGMAZH(16)=HSIGMAM
C
       SIGMAZH(17)=0.
       SIGMAZH(18)=0.
       SIGMAZH(19)=0.
       SIGMAZH(20)=0.
C      
       SIGMAZH(21)=HSIGMAM
       SIGMAZH(22)=HSIGMAM
       SIGMAZH(23)=0.
       SIGMAZH(24)=0.
       SIGMAZH(25)=0.
       SIGMAZH(26)=0.
       SIGMAZH(27)=0.

      RETURN
      END

C     ******************************************************************
      FUNCTION EXI(K,J,I)
      INCLUDE 'T-SNRCS.PAR'
C
      DIST=((I-1)*DEL+0.5*DEL)*XDISP+((J-1)*DEL+0.5*DEL)*YDISP+
     $  ((K-1)*DEL+0.5*DEL)*ZDISP + DELAY

      EXI = AMPX*SOURCE(DIST)
      RETURN
      END
C     ***************************************************************
      FUNCTION EYI(K,J,I)
      INCLUDE 'T-SNRCS.PAR'
C
      DIST=((I-1)*DEL+0.5*DEL*OFF)*XDISP+((J-1)*DEL+0.5*DEL)*YDISP+
     $  ((K-1)*DEL+0.5*DEL)*ZDISP + DELAY

      EYI = AMPY*SOURCE(DIST)
      RETURN
      END
C     ************************************************************
      FUNCTION EZI(K,J,I)
      INCLUDE 'T-SNRCS.PAR'
C

      DIST=((I-1)*DEL+0.5*DEL*OFF)*XDISP+((J-1)*DEL+0.5*DEL)*YDISP+
     $  ((K-1)*DEL+0.5*DEL)*ZDISP + DELAY

      EZI = AMPZ*SOURCE(DIST)
      RETURN
      END

C     ******************************************************************
      FUNCTION HXI(K,J,I)
      INCLUDE 'T-SNRCS.PAR'

      DIST=((I-1)*DEL+0.5*DEL)*XDISP+((J-1)*DEL+0.5*DEL)*YDISP+
     $  ((K-1)*DEL+0.5*DEL)*ZDISP + DELAY

      HXI = AMPHX*SOURCE(DIST)
      RETURN
      END
C     ***************************************************************
      FUNCTION HYI(K,J,I)
      INCLUDE 'T-SNRCS.PAR'

      DIST=((I-1)*DEL+0.5*DEL*OFF)*XDISP+((J-1)*DEL+0.5*DEL)*YDISP+
     $  ((K-1)*DEL+0.5*DEL)*ZDISP + DELAY

      HYI = AMPHY*SOURCE(DIST)
      RETURN
      END
C     ************************************************************
      FUNCTION HZI(K,J,I)
      INCLUDE 'T-SNRCS.PAR'

      DIST=((I-1)*DEL+0.5*DEL*OFF)*XDISP+((J-1)*DEL+0.5*DEL)*YDISP+
     $  ((K-1)*DEL+0.5*DEL)*ZDISP + DELAY

      HZI = AMPHZ*SOURCE(DIST)
      RETURN
      END
C     ********************************************************

      FUNCTION SOURCE(DIST)
      INCLUDE 'T-SNRCS.PAR'
C
      SOURCE = 0.0
      TAU=TT-DIST/CISIK
      SOURCE=-2.3*SQRT(ALPHA)*(TAU-SHIFT)*EXP(-ALPHA*(TAU-SHIFT)**2)
 10   RETURN
      END

C**********************************************
       SUBROUTINE SNRCS
       INCLUDE 'T-SNRCS.PAR'


       DT=DEL/(2*CISIK*HDB)
       CC1=1/CISIK
       DT1=1/DT
       ASBT=1./(DEL*ZO)
       HSBT=1./(2.*ZO*HDB)
       BAND=1.E-9*CISIK/(10.*DEL)

       TETA=TETA*PI/180.
       PHI=PHI*PI/180.

       SPHI=SIN(PHI)
       CPHI=COS(PHI)
       STETA=SIN(TETA)
       CTETA=COS(TETA)

       COSTH=COS(PI*THINC/180.)
       SINTH=SIN(PI*THINC/180.)
       COSPH=COS(PI*PHINC/180.)
       SINPH=SIN(PI*PHINC/180.)
C
C     FIND AMPLITUDE OF INCIDENT FIELD COMPONENTS
C
       AMPX=AMP*(ETHINC*COSTH*COSPH-EPHINC*SINPH)
       AMPY=AMP*(ETHINC*COSTH*SINPH+EPHINC*COSPH)
       AMPZ=AMP*(-ETHINC*SINTH)
C
C     FIND AMPLITUDE OF INCIDENT H_FIELD COMPONENTS
C

       AMPHX=AMP*(ETHINC*SINPH+EPHINC*COSTH*COSPH)/ZO
       AMPHY=AMP*(-ETHINC*COSPH+EPHINC*COSTH*SINPH)/ZO
       AMPHZ=AMP*(-ETHINC*SINPH)/ZO

C
C     FIND RELATIVE SPATIAL DELAY FOR X, Y, Z CELL DISPLACEMENT
C
       XDISP=-COSPH*SINTH
       YDISP=-SINPH*SINTH
       ZDISP=-COSTH

       DELAY=0.0
       IF (XDISP.LT.0.) DELAY=DELAY-XDISP*NX1*DEL
       IF (YDISP.LT.0.) DELAY=DELAY-YDISP*NY1*DEL
       IF (ZDISP.LT.0.) DELAY=DELAY-ZDISP*NZ1*DEL

       RETURN
       END

C*****************************************************************
      SUBROUTINE YAKUZ
      INCLUDE 'T-SNRCS.PAR'
C******************************************************************

C*********************************************
C (1) X=Xmax 
C*********************************************
      ALAN=DEL*DEL
             II=NXS2
        DO KK=NZS1,NZS2
          DO JJ=NYS1,NYS2

            RRP=DEL*(II-IC)*STETA*CPHI+
     *          DEL*(JJ-JC)*STETA*SPHI+
     *          DEL*(KK-KC)*CTETA
            TC=ITIME*DT-RRP*CC1
	    M=INT(TC*DT1+.5)

         EYS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,3)+V(KK,JJ,II,4)+
     >             V(KK,JJ,II,8)+V(KK,JJ,II,11))

         HYS = HSBT*(-V(KK,JJ,II,2)+V(KK,JJ,II,6)+
     >                 V(KK,JJ,II,9)-V(KK,JJ,II,10))

         EZS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,5)+V(KK,JJ,II,6)+
     >             V(KK,JJ,II,7)+V(KK,JJ,II,10)) 

         HZS = HSBT*(V(KK,JJ,II,1)-V(KK,JJ,II,3)+
     >                V(KK,JJ,II,11)-V(KK,JJ,II,12))
            E0=-EYS
	    UZ(M-1)= UZ(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UZ(M)  = UZ(M)+ALAN*E0*2*(TC*DT1-M)
	    UZ(M+1)= UZ(M+1)-ALAN*E0*(.5+TC*DT1-M)

            E0=EZS
	    UY(M-1)= UY(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UY(M)  = UY(M)+ALAN*E0*2*(TC*DT1-M)
	    UY(M+1)= UY(M+1)-ALAN*E0*(.5+TC*DT1-M)

            H0=HYS
	    WZ(M-1) = WZ(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WZ(M)   = WZ(M)+ALAN*H0*2*(TC*DT1-M)
	    WZ(M+1) = WZ(M+1)-ALAN*H0*(.5+TC*DT1-M)

            H0=-HZS
	    WY(M-1) = WY(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WY(M)   = WY(M)+ALAN*H0*2*(TC*DT1-M)
	    WY(M+1) = WY(M+1)-ALAN*H0*(.5+TC*DT1-M)

	  ENDDO
	ENDDO

C********************************************
C (2) X=Xmin 
C********************************************
      ALAN=DEL*DEL
             II=NXS1
        DO KK=NZS1,NZS2
          DO JJ=NYS1,NYS2
            RRP=DEL*(II-IC)*STETA*CPHI+
     *          DEL*(JJ-JC)*STETA*SPHI+
     *          DEL*(KK-KC)*CTETA
            TC=ITIME*DT-RRP*CC1
	    M=INT(TC*DT1+.5)

         EYS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,3)+V(KK,JJ,II,4)+
     >             V(KK,JJ,II,8)+V(KK,JJ,II,11))

         HYS = HSBT*(-V(KK,JJ,II,2)+V(KK,JJ,II,6)+
     >                 V(KK,JJ,II,9)-V(KK,JJ,II,10))

         EZS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,5)+V(KK,JJ,II,6)+
     >             V(KK,JJ,II,7)+V(KK,JJ,II,10)) 

         HZS = HSBT*(V(KK,JJ,II,1)-V(KK,JJ,II,3)+
     >                V(KK,JJ,II,11)-V(KK,JJ,II,12))

            E0=EYS
	    UZ(M-1)= UZ(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UZ(M)  = UZ(M)+ALAN*E0*2*(TC*DT1-M)
	    UZ(M+1)= UZ(M+1)-ALAN*E0*(.5+TC*DT1-M)

            E0=-EZS
	    UY(M-1)= UY(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UY(M)  = UY(M)+ALAN*E0*2*(TC*DT1-M)
	    UY(M+1)= UY(M+1)-ALAN*E0*(.5+TC*DT1-M)


            H0=-HYS
	    WZ(M-1) = WZ(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WZ(M)   = WZ(M)+ALAN*H0*2*(TC*DT1-M)
	    WZ(M+1) = WZ(M+1)-ALAN*H0*(.5+TC*DT1-M)

            H0=HZS
	    WY(M-1) = WY(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WY(M)   = WY(M)+ALAN*H0*2*(TC*DT1-M)
	    WY(M+1) = WY(M+1)-ALAN*H0*(.5+TC*DT1-M)

	  ENDDO
	ENDDO

C********************************************
C (3) y=Ymax 
C********************************************
      ALAN=DEL*DEL
             JJ=NYS2
        DO KK=NZS1,NZS2
          DO II=NXS1,NXS2
            RRP=DEL*(II-IC)*STETA*CPHI+
     *          DEL*(JJ-JC)*STETA*SPHI+
     *          DEL*(KK-KC)*CTETA
            TC=ITIME*DT-RRP*CC1
	    M=INT(TC*DT1+.5)

         EXS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,1)+V(KK,JJ,II,2)+
     >             V(KK,JJ,II,9)+V(KK,JJ,II,12))

         HXS = HSBT*(V(KK,JJ,II,4)-V(KK,JJ,II,5)+
     >                V(KK,JJ,II,7)-V(KK,JJ,II,8))

         EZS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,5)+V(KK,JJ,II,6)+
     >             V(KK,JJ,II,7)+V(KK,JJ,II,10))

         HZS = HSBT*(V(KK,JJ,II,1)-V(KK,JJ,II,3)+
     >                V(KK,JJ,II,11)-V(KK,JJ,II,12))

            E0=EXS
	    UZ(M-1)= UZ(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UZ(M)  = UZ(M)+ALAN*E0*2*(TC*DT1-M)
	    UZ(M+1)= UZ(M+1)-ALAN*E0*(.5+TC*DT1-M)

            E0=-EZS
	    UX(M-1)= UX(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UX(M)  = UX(M)+ALAN*E0*2*(TC*DT1-M)
	    UX(M+1)= UX(M+1)-ALAN*E0*(.5+TC*DT1-M)

            H0=-HXS
	    WZ(M-1) = WZ(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WZ(M)   = WZ(M)+ALAN*H0*2*(TC*DT1-M)
	    WZ(M+1) = WZ(M+1)-ALAN*H0*(.5+TC*DT1-M)

            H0=HZS
	    WX(M-1) = WX(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WX(M)   = WX(M)+ALAN*H0*2*(TC*DT1-M)
	    WX(M+1) = WX(M+1)-ALAN*H0*(.5+TC*DT1-M)

	  ENDDO
	ENDDO

C********************************************
C (4) y=Ymin 
C********************************************
      ALAN=DEL*DEL
             JJ=NYS1
        DO KK=NZS1,NZS2
          DO II=NXS1,NXS2
            RRP=DEL*(II-IC)*STETA*CPHI+
     *          DEL*(JJ-JC)*STETA*SPHI+
     *          DEL*(KK-KC)*CTETA
            TC=ITIME*DT-RRP*CC1
	    M=INT(TC*DT1+.5)

         EXS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,1)+V(KK,JJ,II,2)+
     >             V(KK,JJ,II,9)+V(KK,JJ,II,12))

         HXS = HSBT*(V(KK,JJ,II,4)-V(KK,JJ,II,5)+
     >                V(KK,JJ,II,7)-V(KK,JJ,II,8))

         EZS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,5)+V(KK,JJ,II,6)+
     >             V(KK,JJ,II,7)+V(KK,JJ,II,10))

         HZS = HSBT*(V(KK,JJ,II,1)-V(KK,JJ,II,3)+
     >                V(KK,JJ,II,11)-V(KK,JJ,II,12))

            E0=-EXS
	    UZ(M-1) = UZ(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UZ(M)   = UZ(M)+ALAN*E0*2*(TC*DT1-M)
	    UZ(M+1) = UZ(M+1)-ALAN*E0*(.5+TC*DT1-M)

            E0=EZS
	    UX(M-1) = UX(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UX(M)   = UX(M)+ALAN*E0*2*(TC*DT1-M)
	    UX(M+1) = UX(M+1)-ALAN*E0*(.5+TC*DT1-M)

            H0=HXS
	    WZ(M-1) = WZ(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WZ(M)   = WZ(M)+ALAN*H0*2*(TC*DT1-M)
	    WZ(M+1) = WZ(M+1)-ALAN*H0*(.5+TC*DT1-M)

            H0=-HZS
	    WX(M-1) = WX(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WX(M)   = WX(M)+ALAN*H0*2*(TC*DT1-M)
	    WX(M+1) = WX(M+1)-ALAN*H0*(.5+TC*DT1-M)

	  ENDDO
	ENDDO

C********************************************
C (5) z=Zmax 
C********************************************
      ALAN=DEL*DEL
             KK=NZS2
        DO JJ=NYS1,NYS2
          DO II=NXS1,NXS2
            RRP=DEL*(II-IC)*STETA*CPHI+
     *          DEL*(JJ-JC)*STETA*SPHI+
     *          DEL*(KK-KC)*CTETA
            TC=ITIME*DT-RRP*CC1
	    M=INT(TC*DT1+.5)

         EXS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,1)+V(KK,JJ,II,2)+
     >             V(KK,JJ,II,9)+V(KK,JJ,II,12))

         HXS = HSBT*(V(KK,JJ,II,4)-V(KK,JJ,II,5)+
     >                V(KK,JJ,II,7)-V(KK,JJ,II,8))

         EYS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,3)+V(KK,JJ,II,4)+
     >             V(KK,JJ,II,8)+V(KK,JJ,II,11))

         HYS = HSBT*(-V(KK,JJ,II,2)+V(KK,JJ,II,6)+
     >                 V(KK,JJ,II,9)-V(KK,JJ,II,10))

            E0=-EXS
	    UY(M-1) = UY(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UY(M)   = UY(M)+ALAN*E0*2*(TC*DT1-M)
	    UY(M+1) = UY(M+1)-ALAN*E0*(.5+TC*DT1-M)

            E0=EYS
	    UX(M-1) = UX(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UX(M)   = UX(M)+ALAN*E0*2*(TC*DT1-M)
	    UX(M+1) = UX(M+1)-ALAN*E0*(.5+TC*DT1-M)

            H0=HXS
	    WY(M-1) = WY(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WY(M)   = WY(M)+ALAN*H0*2*(TC*DT1-M)
	    WY(M+1) = WY(M+1)-ALAN*H0*(.5+TC*DT1-M)

            H0=-HYS
	    WX(M-1) = WX(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WX(M)   = WX(M)+ALAN*H0*2*(TC*DT1-M)
	    WX(M+1) = WX(M+1)-ALAN*H0*(.5+TC*DT1-M)

	  ENDDO
	ENDDO

C********************************************
C (6) z=Zmin 
C********************************************
      ALAN=DEL*DEL
             KK=NZS1
        DO JJ=NYS1,NYS2
          DO II=NXS1,NXS2
            RRP=DEL*(II-IC)*STETA*CPHI+
     *          DEL*(JJ-JC)*STETA*SPHI+
     *          DEL*(KK-KC)*CTETA
            TC=ITIME*DT-RRP*CC1
	    M=INT(TC*DT1+.5)

         EXS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,1)+V(KK,JJ,II,2)+
     >             V(KK,JJ,II,9)+V(KK,JJ,II,12))

         HXS = HSBT*(V(KK,JJ,II,4)-V(KK,JJ,II,5)+
     >                V(KK,JJ,II,7)-V(KK,JJ,II,8))

         EYS =-RV(IDCELL(KK,JJ,II))*(V(KK,JJ,II,3)+V(KK,JJ,II,4)+
     >             V(KK,JJ,II,8)+V(KK,JJ,II,11))

         HYS = HSBT*(-V(KK,JJ,II,2)+V(KK,JJ,II,6)+
     >                 V(KK,JJ,II,9)-V(KK,JJ,II,10))

            E0=EXS
	    UY(M-1) = UY(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UY(M)   = UY(M)+ALAN*E0*2*(TC*DT1-M)
	    UY(M+1) = UY(M+1)-ALAN*E0*(.5+TC*DT1-M)

            E0=-EYS
	    UX(M-1) = UX(M-1)+ALAN*E0*(.5-TC*DT1+M)
	    UX(M)   = UX(M)+ALAN*E0*2*(TC*DT1-M)
	    UX(M+1) = UX(M+1)-ALAN*E0*(.5+TC*DT1-M)

            H0=-HXS
	    WY(M-1) = WY(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WY(M)   = WY(M)+ALAN*H0*2*(TC*DT1-M)
	    WY(M+1) = WY(M+1)-ALAN*H0*(.5+TC*DT1-M)

            H0=HYS
	    WX(M-1) = WX(M-1)+ALAN*H0*(.5-TC*DT1+M)
	    WX(M)   = WX(M)+ALAN*H0*2*(TC*DT1-M)
	    WX(M+1) = WX(M+1)-ALAN*H0*(.5+TC*DT1-M)

	  ENDDO
	ENDDO

	RETURN
	END

