C*********************************************************      
C     PROGRAM   : SPART.FOR                              *
C     DATE      : MAY 2002                               *
C     AUTHOR    : LEVENT SEVGI                           *
C     PURPOSE   : FREQUENCY ANALYSIS OF TLMMS PACKAGE    *
C*********************************************************
      PARAMETER(NT=9000)
      REAL VS1(NT),VY1(NT),VS2(NT),VSL(NT),TIME(NT)
      COMPLEX CVS1,CVY1,CVS2,CAS1,CAS2,CVSL,J,S11,S21
      PARAMETER(C=3.E8,PI=3.1415927)

C----- VSL(NT) : MICROSTRIP LINE INCIDENT VOLTAGE ------- 
C----- VS1(NT) : MICROSTRIP CIRCUIT INPUT TOTAL VOLTAGE ------- 
C----- VS2(NT) : MICROSTRIP CIRCUIT OUTPUT VOLTAGE ------- 
C----- AS1(NT) : MICROSTRIP CIRCUIT INPUT CURRENT ------- 
C----- AS2(NT) : MICROSTRIP CIRCUIT OUTPUT CURRENT ------- 

      OPEN(11,FILE='MSTRIP.INP')
      READ(11,*) NTYPE !
      READ(11,*) H !STRIP HEIGHT [mm] 
      READ(11,*) ND ! PARAMETER [ ] 
      READ(11,*) NSTOP 

      DELX=H*1.E-3/6.
      DELY=DELX
      DELZ=2.*DELX

      J=CMPLX(0.0,1.0)
      FMAX=C/(20.*DELZ) !40 SAMPLES FOR MINIMUM WAVELENGTH 
      DF=FMAX/500.
      ARG=2.*PI

      DO IT=1,NT
        VSL(IT)=0.
        VS1(IT)=0.
        VS2(IT)=0.
        VY1(IT)=0.
      END DO

      OPEN(UNIT=12,FILE='MST-LINE.DAT')
      DO IT=1,NSTOP
        READ(12,*,err=122) TIME(IT),VSL(IT),DUM2
        TIME(IT)=TIME(IT)*1.E-9 
      END DO
122   continue
      CLOSE(12)

      OPEN(UNIT=12,FILE='MST-STR.DAT')
      DO IT=1,3200
        READ(12,*,err=132) dummy,VS1(IT),VS2(IT)
        VY1(IT)=VS1(IT)-VSL(IT)
      END DO
132   continue
      CLOSE(12)


      OPEN(UNIT=20,FILE='SPART.DAT')

      I=0
      DO F=DF,FMAX,DF
	 I=I+1
         CVSL=CMPLX(0.0,0.0)
         CVS1=CMPLX(0.0,0.0)
         CVS2=CMPLX(0.0,0.0)
         CVY1=CMPLX(0.0,0.0)

         DO IT=1,NSTOP
           CVSL=CVSL+VSL(IT)*CEXP(-J*ARG*F*TIME(IT))
           CVY1=CVY1+VY1(IT)*CEXP(-J*ARG*F*TIME(IT))
           CVS2=CVS2+VS2(IT)*CEXP(-J*ARG*F*TIME(IT))
	 END DO

         IF (CVSL.NE.0.) THEN
           S11=cabs(CVY1/CVSL)
           S21=cabs(CVS2/CVSL)
           WRITE(20,*) F*1E-9,20.*LOG10(cabs(S11)),20.*LOG10(cabs(S21))
         ENDIF
      END DO
      CLOSE(20)

      STOP
      END
      
