C********************************************************
C     PROGRAM     : T-SNDFT.FOR                         *
C     DATE        : JULY 1998                           *
C     AUTHOR      : LEVENT SEVGI                        *
C     PURPOSE     : DFT ANALYSIS OF TIME DOMAIN TLM     *
C                   DATA AND TO OBTAIN RCS VS. FREQ     *
C                   ALONG A CHOSEN DIRECTION
C********************************************************
      REAL EYT(1200),FETETA(1200),FEPHI(1200)
      REAL TIME(1200),PI,LAMDA2,EX(1200),EY(1200),EZ(1200)
      COMPLEX CFETETA,CFEPHI,J,CTT,CX,CY,CZ


      OPEN(UNIT=30,FILE='SNRCS.INP')
      OPEN(UNIT=32,FILE='T-SNRCS.DAT')
      OPEN(UNIT=14,FILE='T-SOURCE.DAT')
      OPEN(UNIT=22,FILE='T-SNFAR.DAT')
      OPEN(UNIT=44,FILE='TSOURCE-F.DAT')

      READ(30,*) NTYPE     !1-5 SCENARIO TYPE
      READ(30,*) O_LENGTH  !LONGEST DIMENSION 
      
      IF (NTYPE.EQ.1.OR.NTYPE.EQ.5) THEN
         DELX=O_LENGTH/80.
      ELSE
         DELX=O_LENGTH/40.
      ENDIF

      FMAX=3.E8/(10.*DELX)
      DELF=FMAX/100.

      DO I=1,1200
         EX(I)=0.
         EY(I)=0.
         EZ(I)=0.
      ENDDO

      PI=4.0*ATAN(1.0)
      J=CMPLX(0.0,1.0)
      ARG=2.0*PI

      NT=801

      DO K=1,(NT-201)
         READ(14,*,ERR=100) TT,EX(K),EY(K),EZ(K)
	END DO
100   CONTINUE
	

	DO K=1,NT
        READ(22,*) TIME(K),FETETA(K),FEPHI(K)  ! TIME in nsec
        TIME(K)=TIME(K)/1.E9
	END DO

      DO FREQ=DELF,FMAX,DELF
	   CFETETA=CMPLX(0.0,0.0)
	   CFEPHI=cmplx(0.,.0)
         CX=cmplx(.0,.0)
         CY=cmplx(.0,.0)
         CZ=cmplx(.0,.0)
	   DO K=1,NT
	     CFETETA=CFETETA+FETETA(K)*CEXP(-J*ARG*FREQ*TIME(K))
	     CFEPHI = CFEPHI+FEPHI(K)*CEXP(-J*ARG*FREQ*TIME(K))
           CX=CX+EX(K)*CEXP(-J*ARG*FREQ*TIME(K))
           CY=CY+EY(K)*CEXP(-J*ARG*FREQ*TIME(K))
           CZ=CZ+EZ(K)*CEXP(-J*ARG*FREQ*TIME(K))
	   END DO
         CTT=CSQRT(CX**2+CY**2+CZ**2)
         YY=4.*PI*(CABS(CFETETA)/CABS(CTT))**2
         ZZ=4.*PI*(CABS(CFEPHI)/CABS(CTT))**2
         WRITE(32,*) FREQ/1.E6,10.*LOG10(YY),10.*LOG10(ZZ)
	   WRITE(44,*) FREQ/1.E6,CABS(CZ)
      END DO
      
      CLOSE(32)
      CLOSE(22)
      CLOSE(12)
    
       STOP
       END
      
